/*************************************************************
*							     *
*  Program: Neural Net Simulator			     *
*							     *
*  Author: Greg Tarr                  Date:19 May 1990       *
*							     *
*  Module: Hopfield Associative Memory  		     *
*  SubModules:Hmakein, Hmenu, Net.h                          *
*  Super Module: title.c                                     *
**************************************************************/

#include <graphics.h>
#include <stdio.h>
#include <alloc.h>

#include <defines.h>

extern setup parameters;
int hop_screen();
hopfield_net htest,hnoise,houtput;
int wide,high;
extern int examplars,sample;
char *weightsx;
float anoise = 0.1;
extern int vector,*data,reset;
#define check_keyboard if(kbhit())break;
int vector;

void hopfield()
{ int i=0,j,k;char do_what;
strcpy(parameters.dirmask,"*.hop");
while(TRUE){
INIT_hopfield();
do_what = 0;
while(do_what == 0){i++;
     MAKEINPUT();
     loopj(10){
	train_hopfield(j);
	check_keyboard; }
	if(kbhit()){do_what = gmenu("hopfield.doc",hop_screen);}
	      }
free_hopfield();
if(do_what == 'q') break;
}
reset = TRUE;
reset_directories();
}



INIT_hopfield()
{
  init_hopfield();
  write_gmenu();
  hinit_data();
  display_hopfield();
  init_nets();  /* memory for htest,hnoise, and houtput */
  train_weights();

}

train_hopfield(j)
int j;
{ gotoxy (55,13);printf("Iteration: %2d",j);
	hdisplay(400,80,houtput.inputx);
	process(houtput.inputx);
	}

char *Hmalloc(x)
int x;
{ char *vec;
  vec = (char *)malloc(sizeof(char)*x);
  if(vec == NULL) {printf("No core left in hopfield");exit(0);}
  return vec;}
int *Himalloc(x)
int x;
{ int *vec;
  vec = (int *)malloc(sizeof(int)*x);
  if(vec == NULL) {printf("No core left in hopfield");exit(0);}
  return vec;

}
init_nets()
{
weightsx       = Hmalloc(vector*vector);
htest.inputx   = Himalloc(wide*high);
hnoise.inputx  = Himalloc(wide*high);
houtput.inputx = Himalloc(wide*high);
}

free_hopfield(){
free(htest.inputx);
free(hnoise.inputx);
free(houtput.inputx);
free(data);
free(weightsx);
}

MAKEINPUT()
{int i,j,k;
HMAKE_INPUT(htest.inputx,-1);
hdisplay(50,80,htest.inputx);
corrupt_hopfield(htest.inputx,hnoise.inputx);
hdisplay(220,80,hnoise.inputx);}


init_hopfield()
{make_screen();
 hop_screen();}
 hop_screen()
 {
 setviewport(0,0,639,349,1);
 setbkcolor(DARKGRAY);
 setcolor(BLUE);
 clearviewport();
 rectangle(1,1,639,349);
 rectangle (1,30,639,319);
 settextstyle(1,0,3);
 setcolor(CYAN);
 outtextxy(150,320,"Hopfield Associative Memory");
 settextstyle(2,0,4);
 outtextxy(50,60,"Desired Output");
 outtextxy(220,60,"Corrupted Output");
 outtextxy(420,60,"Net Output");
 write_gmenu();
 }

static int dot[8] = { 128,64,32,16,8,4,2,1};

hdisplay(x,y,example)
int x,y;
int example[];

{ int i,j,k,x1,y1;

  int windowx, windowy;
  windowx = 10 * wide+1;
  windowy = 8 * high+1;
  rectangle(x-1,y-1,x+windowx+1,y+windowy+1);

   setfillstyle(SOLID_FILL,BLUE);
   setcolor(BLUE);
   loopi(high){
       loopj(wide){ x1 = j*10+x;
		    y1 = i*8+y;
		    if(example[j+i*wide] == 1)setfillstyle(1,BLUE);
		    else setfillstyle(1,YELLOW);
		      bar(x1,y1,x1+10,y1+8);
		      rectangle(x1,y1,x1+10,y1+8);
			 }}
gotoxy(40,20);printf("Corruption %3.2f ",anoise);}

hdisplay_small(x,y,example)
int x,y,*example;
{ int i,j,k,x1,y1;
  int windowx, windowy;
  windowx = 5 * wide;
  windowy = 4 * high;
  setviewport(x,y,x+windowx,y+windowy,1);
   clearviewport();
   setviewport(1,1,639,349,1);
   rectangle(x,y,x+windowx,y+windowy);
   setcolor(BLUE);
   setfillstyle(SOLID_FILL,BLUE);
   loopi(high){
       loopj(wide){ x1 = j*5+x;
		    y1 = i*4+y;
		    if(example[j+i*wide] == 1)setfillstyle(SOLID_FILL,BLUE);
		    else setfillstyle(SOLID_FILL,YELLOW);
		    bar(x1,y1,x1+5,y1+4);
		    rectangle(x1,y1,x1+5,y1+4);
		      }}}


corrupt_hopfield(inx,outx)
   int *inx,*outx;
   {int i,j,index,corruption;
   if(anoise != 0.0) corruption = (int)(1./anoise);
   else corruption = 100000;
   loopi(wide*high)
       { outx[i] = inx[i]; if(rand()%corruption == 0) outx[i] *= -1;
	  houtput.inputx[i] = outx[i];}}

process(u)
   int u[];
{    int i=0,j,k;
     int x,y[64];
     loopj(wide*high){ x = 0;
	loopi(wide*high)
	  { x += weightsx[vector*j+i]*u[i];};
	    if(x < 0 ) houtput.inputx[j] = -1;
		  else houtput.inputx[j] =  1; }}

display_hopfield()
{ int i,j,k;
for(i=0;i<examplars;i++)
  {  hdisplay_small(100+wide*6*i,200,&data[i*vector]); }}

write_it(over,vector)
int over,vector[];
{ int i,j;
  loopi(high*wide)
  {   if((i % wide )== 0) gotoxy(over,i/wide+1);
      if(vector[i] == 1) printf("*",vector[i]);
      else printf(" "); }}

train_weights()
{ int i,j,k;

  hopfield_net *hnet;

  hnet = (hopfield_net *)malloc(sizeof(hopfield_net)*examplars);
  loopi(examplars){ hnet[i].inputx = (int *)malloc(sizeof(int)*vector);
		    if(hnet[i].inputx ==NULL) {printf("train Weights error  ");exit(0);}}

  loopi(examplars){HMAKE_INPUT(hnet[i].inputx,i); }

  loopi(vector){
  loopj(vector){ weightsx [high*wide*i+j] = 0;
     if (i != j) {
     loopk(examplars)
	 { weightsx[vector*i+j] +=hnet[k].inputx[j]*hnet[k].inputx[i]; }
	    }}}

loopi(examplars){free(hnet[i].inputx);};
free(hnet);
}

rectfi(x,y,x1,y1)
int x,y,x1,y1;
{ int boxer[8];

/*  bar(x,y,x1,y1);*/

  boxer[0]=boxer[6]=x;
  boxer[1]=boxer[3]=y;
  boxer[2]=boxer[4]=x1;
  boxer[5]=boxer[7]=y1;
fillpoly(4,boxer);
}

HMAKE_INPUT(x,randx)
int *x;
int randx;
{ int i,j,lpcount;
if(randx < 0 ){sample = rand() % examplars;}
	 else {sample = randx;}
loopi(high*wide)
       {x[i]= data[sample*vector+i];}}
extern FILE *open_data_file();
hinit_data()
{ char filename[80],fname[80];
 int i,j,x;
 float y,z;
 FILE *fp,*fc;
 char target[4],aname[80];
  setviewport(20,50,600,300,1);
  strcpy(aname,"hop3.hop");
  while(TRUE){
	file_window(50,50);
	settextstyle(SMALL_FONT,0,4);

	get_file_name(aname);
	if(open_data_file(aname)){fp=fopen(aname,"r");break;}}
  restore_viewport();
	hop_screen();
	write_gmenu();
         fscanf(fp,"%d %d %d",
		&examplars,&wide,&high);
		vector = high*wide;
	 data=(int *)malloc(sizeof(int)*vector*examplars);
	 if(data== NULL) {
	 printf("request %d coreleft %d ",
	      sizeof(int)*vector*examplars,coreleft());
	 printf("data == NULL");exit(0);}

	 loopi(examplars){ fscanf(fp,"%d",&x);
	    loopj(vector){
		fscanf(fp,"%d",&data[i*vector+j]);
		if (data[i*vector+j] == 0) data[i*vector+j] = -1;
			}


	    }             fclose(fp);


}

