/*************************************************************
*							     *
*  Program: Neural Net Simulator			     *
*							     *
*  Author: Greg Tarr                  Date:19 May 1990       *
*							     *
*  Module: defines.h    				     *
*  SubModules: none                                         *
*  Super Module: title.c                                     *
**************************************************************/
#define TABLE 128
#define Bytes_color 256
#define HIS_SIZE 80
#define loopi(ON) for(i=0;i<ON;i++)
#define loopj(ON) for(j=0;j<ON;j++)
#define loopk(ON) for(k=0;k<ON;k++)
#define loopij(ONE,TWO) for(i=0;i<ONE;i++)for(j=0;j<TWO;j++)
#define MY_BLACK 5
#define backward_loopi(ON) for(i=(ON-1);i>=0;i--)
#define backwardx_loopi(ON) for(i=(ON);i>0;i--)

#define HARD_ON  RED
#define INDETERM (TABLE/2)
#define HARD_OFF BLUE

#define MALLOC(A,B,C,D) A=(B*)malloc(sizeof(B)*(C));check_malloc(A,D);
#define FILL(A,B,C) loopi(C){A[i]=B;}
#define FILL_RANDOM(A,B) loopi(B){A[i]=randomy();}


#define line printf("\n")
#define disply 100
#define weight_s 20
#define video 1.00
#define TRUE 1
#define FALSE 0

#define RETURN 13
#define ESC    27
#define UP     72
#define DOWN   80
#define RIGHT  77
#define LEFT   75
#define square(X) ((X)*(X))

#define wait(A) if((count%(A))==0)

#define barit bar(x1,y1,x1+wide2+4,y1+high2+4)
#define bartext(tstring) outtextxy(x1+wide2-textwidth(tstring),y1,tstring);


typedef struct  {
int size_input,size_output;
float *input,*output;
float **weights,**momentum;
float *delta,*theta,*gamma,*deltheta;
void (* updater)();
float (* propagate)();
float eta[5];
int square;
} layer;

typedef struct  {
int layers;
float *inp,*outp,*doft;
layer *layer1[10];
void (* special)();
                } nnet;


typedef struct {

int train_rule,layers;
int input,output,hide[5];
int examplars,exam_test;
int snormal,sencode,sprepro;
char file[80],weights[80],dirmask[30];
float *history,add_noise;
int indexx,reset,dimension,READY;
} setup;



typedef struct {
char choice;
float fvalue;
int ivalue;
char string[80];
}datax ;

typedef struct {
     char name[80];
     void (* place)();} ITEMS;

typedef struct {
char name[80];
int x,y;
char init[12];
int field;
} places;

#define slines setlinestyle(0,0,1);

#define CLASS  0
#define BINARY 1
#define VECTOR 2
#define RESERVED 3
typedef struct { float r,i;}complex;

typedef struct {long count;
		int right,good;
		} Controls;


/************ For Hopfield nets only ****************/

#define size2 120
typedef struct {
 int *inputx;
 }hopfield_net;