/*************************************************************
*							     *
*  Program: Neural Net Simulator			     *
*							     *
*  Author: Greg Tarr                  Date:19 May 1990       *
*							     *
*  Module: Kohonen Maps 				     *
*  SubModules:                                               *
*  Super Module: title.c                                     *
**************************************************************/

#include <stdio.h>
#include <math.h>
#include <dos.h>
#include <stdlib.h>
#include <alloc.h>
#include <graphics.h>
#include <defines.h>

int jmax = 2;   /* no of inputs */
int side;
int net_size;
int imax ;
/* define size of one side */
int koh_screen();
#define fside (float)side
#define a0 0.4   /* starting gain */
#define g 0.2    /* initialzation factor */
#define cl 1     /* color use in plotting points */

#define KMALLOC(A,B,C) A=(B*)malloc(sizeof(B)*C);if(A==NULL){printf("memory alloc error");exit(0);}

#define xw 300  /* define x width of plotting window */
#define yw 200  /* define y width of plotting window */
#define xba 50  /* where x=0 is on screen */
#define yba 80   /* where y=0 is on screen */

enum densityfunctions {square, triangle, cross,readin};

int step=0,t1,t,t2,w0,w,h1,h,v1,v,i,j,c,statx,staty,clas;
extern int reset;
float a,a1,a2,miny;
float *Kweights,*Kx,*x,*n,*y;

float randomx(),rand1();
extern char gmenu();
enum densityfunctions densityfunction;
extern ITEMS items[];
kohonen()
{  char do_what;

while(TRUE){
   do_what = 0;
   koh_screen();
   side = 5;
   select();
   imax = side*side;

   KMALLOC(Kweights,float,imax*jmax);
   KMALLOC(Kx,float,jmax);
   initi_net();
   display_net();t=0;
   while(do_what == 0){  Kohonen_step();
		      {  do_what = gmenu("help\\kohonen.doc",koh_screen);
				    }}

    free(Kweights);
    free(Kx);
    if(do_what == 'r') continue;
    if(do_what == 'q') break;
}
reset = TRUE;
}   /* end main program */


Kohonen_step()
{
	if ((t % t2) == 0) display_net();
	step++;t++;
	makeKinput();
	feedkoh();
	updateweights();
	if(t>t1){t=1; a = 0.2*a; w0=0; t1=5*t1; t2=5*t2;}

}
initi_net()
{  a = a0; a1 = a; w0 = side / 2; t1 = 1000; t2 = 20; t = 0;

   KMALLOC(n,float,imax);
   KMALLOC(y,float,imax);
   for (i=0; i<imax; i++)  { /* loop on number of nodes */
      n[i] = 0.0;            /* set temp storage of output to zero */
      for (j=0; j<jmax; j++)  {
			     /* loop on number of weights per node */
	 Kweights[i*jmax+j] = (0.5-g/2.0) + g*((float)rand() / 32768.0);
			     /* fill weights with random number */
	 n[i] = n[i] + Kweights[i*jmax+j]*Kweights[i*jmax+j];
      }   /* end j loop */
      n[i] = n[i] / 2.0;  /* not really sure why kohonen did this */
   }   /* end i loop */

 }
feedkoh()
{        miny = n[0]; /* set storage for winner to first node[0] */
	 for (i=0; i<imax; i++)  { /* loop through all nodes */
	    y[i] = n[i];  /* set temp value */
	    for (j=0; j<jmax; j++) y[i] = y[i] - Kweights[i*jmax+j] * Kx[j];
	    if (y[i]<= miny)  {
               miny = y[i];
               c = i;
            }   /* end if */
         }   /* end for i loop */
mapwindow(c);
}
updateweights()
{
         a1 = a*(1.0 - (float)t/(float)t1);  a2 = 1.0 - a1;
         h1 = c % side;
         v1 = c / side;
         w = (int)((float)w0 * (1.0 - (float)t/(float)t1)) + 1;

         for (h=max(0,h1-w); h<=min(side-1,h1+w); h++)  {
            for (v=max(0,v1-w); v<=min(side-1,v1+w); v++)  {
               i = side*v +h; n[i] = 0.0;
               for (j=0; j<jmax; j++)  {
		  Kweights[i*jmax+j] = a1*Kx[j] + a2*Kweights[i*jmax+j];
		  n[i] +=  Kweights[i*jmax+j]*Kweights[i*jmax+j];
               }   /* end for j loop */
               n[i] = n[i] / 2.0;
            }   /* end for v loop */
         }   /* end for h loop */

}

select()
{  ITEMS aitem[5];
   char d;
   int getarrow;
   settextstyle(2,0,4);
   clear_small_window();
   setcolor(YELLOW);

   outtextxy(60,90,"Density functions :");
   outtextxy(60,255,"Use Arrow Keys then Return ");
   setcolor(WHITE);
   densityfunction = square;

   strcpy(aitem[0].name,"   Square  ");
   strcpy(aitem[1].name,"   Triangle");
   strcpy(aitem[2].name,"   Cross   ");

   densityfunction=do_choice(aitem,70,120,3);

   setcolor(YELLOW);
   outtextxy(210,90,"Net work Size :");
   setcolor(WHITE);

   strcpy(aitem[0].name,"   5 x 5  ");
   strcpy(aitem[1].name,"  10 x 10 ");
   strcpy(aitem[2].name,"  15 x 15 ");
   strcpy(aitem[3].name,"  20 x 20 ");

   side=5*(do_choice(aitem,210,120,4)+1);

   setcolor(YELLOW);
   outtextxy(70,170,"Probability functions :");
   setcolor(WHITE);

   strcpy(aitem[0].name,"   Random      ");
   strcpy(aitem[1].name,"   Gaussian    ");
   strcpy(aitem[2].name,"   Chi Squared ");
   statx=do_choice(aitem,70,190,3);
   staty=do_choice(aitem,210,190,3);

   clear_small_window();
}   /* end of askdensityfunction */

do_choice(the_items,x,y,item_max)
ITEMS the_items[];
{  int the_choice=0,getarrow;
   while(TRUE){  display_choices(the_items,x,y,item_max,the_choice);
		 getarrow = getch();
		 the_choice = do_arrow(getarrow,item_max,the_choice);
		 if(getarrow == 13) break;
	       }
	       return the_choice;
}

makeKinput()
{
   int inside;

   inside = 0;
   while (inside == 0)  {

      Kx[0] = randomx(statx);
      Kx[1] = randomx(staty);

      switch (densityfunction)  {
         case square   : inside = 1;
                         break;
	 case triangle : if (Kx[1] > 2.0*fabs(Kx[0] - 0.5)) inside = 1;
                         break;
	 case cross    : if ((fabs(Kx[0]-0.5) <= 0.125) ||
			       (fabs(Kx[1]-0.5) <= 0.125)) inside = 1;
                         break;
      }   /* end of case */
   }   /* end while loop */
   if ((Kx[0] > 0.4) & (Kx[1] > 0.4)) clas = 0;
	else                      clas = 1;
pointwindow(Kx[0],Kx[1]);
}
float randomx(stats)
int stats;
{ float x=0.0;
  int i,j,k;
 switch(stats){
 case 0:  x = rand1();
	  break;
 case 1: for (i=0;i<5;i++) x = x + rand1();
          x = x /5.;
	  break;
 case 2: x = (rand1()-0.5) * (rand1()-0.5) + 0.5;
	 break;}

         return x;
  }
float rand1()

{  float x;
     x =(float)(rand() % 100);
     x = x / 100.;
     return x;
     }
display_net()
{
   int x1,y1,x2,y2;
   float ftx;
   clear_small_window();
   /* put into hi-res mode */
  setcolor(YELLOW);
   switch (densityfunction)  {
      case square   : rectangle(xba,yba,xw+xba,yw+yba);
                      break;
      case triangle : moveto(xba+xw/2,yba);
		      lineto(xba,yba+yw);
		      lineto(xba+xw,yba+yw);
		      lineto(xba+xw/2,yba);
                      break;
      case cross    : moveto(xba+xw*3/8,yba);
		      lineto(xba+xw*5/8,yba);
                      lineto(xba+xw*5/8,yba+yw*3/8);
		      lineto(xba+xw,yba+yw*3/8);
                      lineto(xba+xw,yba+yw*5/8);
		      lineto(xba+xw*5/8,yba+yw*5/8);


		      lineto(xba+xw*5/8,yba+yw);
                      lineto(xba+xw*3/8,yba+yw);
		      lineto(xba+xw*3/8,yba+yw);
                      lineto(xba+xw*3/8,yba+yw*5/8);

		      lineto(xba,yba+yw*5/8);
                      lineto(xba,yba+yw*3/8);

		      lineto(xba+xw*3/8,yba+yw*3/8);
                      lineto(xba+xw*3/8,yba);

                      break;
   }   /* end of case */
   gotoxy(2,22);
   printf("    Step %3d \n", step);
   printf("    Alpha %4.3f \n", a1);
   printf("    Neighborhood %3d\n",w);

   make_scale();

   setcolor(YELLOW);
   for (h=0; h<side; h++)  {

      x1 = (xw * Kweights[h*jmax+0]) + xba;
      y1 = (yw * Kweights[h*jmax+1]) + yba;
      x2 = (xw * Kweights[side*h*jmax+0]) + xba;
      y2 = (yw * Kweights[side*h*jmax+1]) + yba;
      setcolor(BLUE); circle(x2,y2,2);setcolor(YELLOW);


      drawline(&x1,&y1,h,side); drawline(&x2,&y2,side*h,1);

      for (v=1; v<side-1; v++)  {

	 drawline(&x1,&y1,side*v+h,0);
         drawline(&x1,&y1,side*v+h,side);
         drawline(&x2,&y2,side*h+v,0);
         drawline(&x2,&y2,side*h+v,1);
	 setcolor(BLUE); circle(x2,y2,2);setcolor(YELLOW);


      }   /* end for v loop */

      drawline(&x1,&y1,side*(side-1)+h,0);
      drawline(&x2,&y2,side*h+side-1,0);
      setcolor(BLUE); circle(x2,y2,2);setcolor(YELLOW);


   }   /* end for h loop */

}   /* end drawdistribution */

 write_gmenu(){
 int col1=0,col2= CYAN,col3=YELLOW;

 settextstyle(2,0,4);

 aboxer( 20,4,"Quit  ",col1,col2,col3);
 aboxer(100,4,"Pause  ",col1,col2,col3);
 aboxer(180,4,"Restart  ",col1,col2,col3);
 aboxer(600,4,"HELP ",col1,col2,col3);
}

make_scale()
{ float ftx;
  int i,j,k;
   char junk[20];
   setcolor(CYAN);
   for(i=0,ftx=0.0;i<10;i++,ftx += 0.1){
   moveto(xba+ftx*xw,yba);lineto(xba+xw*ftx,yba-5);
   moveto(xba,yba+ftx*yw);lineto(xba-5,yba+ftx*yw);
   sprintf(junk,"%2.1f",ftx);outtextxy(xba-30,yba+ftx*yw-5,junk);
			     outtextxy(xba+ftx*xw-5,yba-20,junk);  }

}
clear_small_window()

{  setviewport(xba+1,yba+1,xw+xba-1,yw+yba-1,1);
   clearviewport();
   setviewport(0,0,639,349,1);
   setcolor(YELLOW);
   rectangle(xba-1,yba-1,xw+xba+1,yw+yba+1);
 }

drawline(xb,yb,i2,e)
   int *xb,*yb,i2,e;
{
   int xo,yo;

   xo = *xb;
   yo = *yb;
   *xb = ((xw/2.0) * (Kweights[i2*jmax+0] + Kweights[(i2+e)*jmax+0])) + xba;
   *yb = ((yw/2.0) * (Kweights[i2*jmax+1] + Kweights[(i2+e)*jmax+1])) + yba;
   moveto(xo,yo);lineto(*xb,*yb);
/*   draw(xo,yo,*xb,*yb);  */

}   /* end drawline */



/* draw a line in specified color -- good for any mode */
/*
draw(startx, starty, endx, endy)
int startx, starty, endx, endy;
{
   line(startx,starty,endx,endy);
}
  */

koh_screen()
{
setviewport(0,0,639,349,1);
  setbkcolor(DARKGRAY);
  clearviewport();
  setcolor(CYAN);
  rectangle(1,1,639,349);
  settextstyle(TRIPLEX_FONT,0,5);
  setcolor(BLUE);
  outtextxy(20,20,"KOHONEN MAP");
  setcolor(CYAN);
  outtextxy(15,15,"KOHONEN MAP");
  setlinestyle(0,0,1);
  setcolor(BLUE);
  rectangle(400,50,550,150);
  settextstyle(2,0,4);
  setcolor(BROWN);
  outtextxy(400,160,"Exemplar Points");
  settextstyle(2,0,5);
  outtextxy(70,260,"Kohonen Decision Regions");
  setcolor(YELLOW);
  outtextxy(400,320,"Kohonen Map");
 rectangle(400,200,550,300);
write_gmenu();
  }

pointwindow(x,y)
float x,y;
{ int z;
if(clas == 0)z=YELLOW;
else z=RED;
x=(int)(x*xw)/2+400;
y=(int)(y*yw)/2+50;
putpixel(x,y,z);
}
mapwindow(c)
int c;
{ float x,y;
  int z;
if (clas==0) z = YELLOW;
         else z = RED;
x = (float)(c/side)/fside;
y = (float)(c % side)/fside;
x=(int)(x*xw)/2+405;
y=(int)(y*yw)/2+205;
setcolor(z);
rectangle(x,y,x+2,y+2);
}
