/*************************************************************
*							     *
*  Program: Neural Net Simulator			     *
*							     *
*  Author: Greg Tarr                  Date:19 May 1990       *
*							     *
*  NAME: Module for Backprop                                 *
*  MODULE NUMBER: 1.6                                        *
*  DESCRIPTION: Using output, adjusts wights reduce error.   *
*  ALGORITHM: Werbos Multilayer Perceptron Backpropagation.  *
*  Super Module: title.c                                     *
**************************************************************/
#include <stdlib.h>
#include <defines.h>
#include <math.h>

/* main storage items */

extern nnet *net;
extern setup parameters;

/* Fuction Prototypes */

float calcy_linear(layer*,int);
float calcy(layer*,int),fixy(float,float);
void  dely(float*,float*,float*,int);
void  delx(float*,float*,float*,float**,int,int);
void  adjust_weights(layer*);

extern int reset;
extern float neta,momentum;

void TRAIN_LOWER_LAYER(),
     TRAIN_OUTPUT_LAYER();

void init_train_BACKPROP()
{int i;
 strcpy(parameters.dirmask,"*.dat");
  reset = FALSE;
 if(!parameters.READY) return;
 init_net(parameters);
 loopi(parameters.layers){
	   net->layer1[i]->updater = TRAIN_LOWER_LAYER;
	   net->layer1[i]->propagate = calcy;
	   net->layer1[i]->eta[0] = neta;
	   net->layer1[i]->eta[1] = momentum; }
           net->layer1[parameters.layers-1]->updater = TRAIN_OUTPUT_LAYER;
}


void TRAIN_OUTPUT_LAYER (l_on,l_up)
layer *l_on,*l_up;
{ int i,j,k;
  float neta;
  if(l_up == NULL);
  dely(l_on->output,net->doft,l_on->delta,l_on->size_output);
  adjust_weights(l_on);
}
void TRAIN_LOWER_LAYER(l_on,l_up)
layer *l_on,*l_up;

{ int i,j,k,lower,upper;
  float neta;
  /* derive error */
  delx(l_on->output,l_up->delta,l_on->delta,
	      l_up->weights,l_up->size_output,l_on->size_output);

  adjust_weights(l_on);

}
void adjust_weights(layer *l_on)
{ int i,j;
  float eta;

  eta = l_on->eta[0]/(float)l_on->size_input;
  loopj(l_on->size_output) {
  l_on->theta[j] =  l_on->theta[j] + eta * l_on->delta[j] ;
    loopi(l_on->size_input) {
      l_on->weights[j][i] +=  eta * l_on->delta[j] * l_on->input[i];
               }}


}

float calcy(layer *l_on,int number)
 { return fixy(calcy_linear(l_on,number),0.5);}

float calcy_linear(layer *l_on,int number)
 {int i;
   float y=0.0;
   loopi(l_on->size_input){y=y+l_on->input[i]*l_on->weights[number][i];}
   y = y + l_on->theta[number];
   return y;}

float fixy(float y,float hardness)
{ float xx;
  if (y >  20.) return 1.;
  if (y < -20.) return 0.;
  return ( 1.0/(1.0 + (float)exp(-(double)(hardness * y))));

}
void dely(y,doft,del,output) /* computer error vector for output         */
float *y,*doft,*del;       /* Interface requires computed output         */
int output;                /* Desired output and storage for error: del. */
 { int i;
loopi(output){ del[i] = (y[i]*(1.0-y[i]))*(doft[i]-y[i]);}
}
void delx(x,del,del_down,w,upper,lower)
   float *x,*del,*del_down,**w;
   int upper,lower;
 { float sum;
   int i,j;
   loopj(lower){
   sum = 0.0;
   loopi(upper) { sum = sum + del[i] * w[i][j];}
   sum = (x[j]*(1.0-x[j])) * sum;
   del_down[j] = sum;}
   }

