/*************************************************************
*							     *
*  Program: Neural Net Simulator			     *
*							     *
*  Author: Greg Tarr                  Date:19 May 1990       *
							     *
*  NAME: Module for Backprop with momentum                   *
*  MODULE NUMBER: 1.6                                        *
*  DESCRIPTION: Using output, adjusts wights reduce error.   *
*  ALGORITHM: Werbos Multilayer Perceptron Backpropagation.  *
*							     *
*  Module: 						     *
*  SubModules:                                               *
*  Super Module: title.c                                     *
**************************************************************/
#include <stdlib.h>
#include <defines.h>
#include <math.h>

#include "percp\bp.h"

extern nnet *net;

extern setup parameters;

extern int reset;

void adjust_weights2(layer*);

void TRAIN_LOWER_LAYER2(layer *,layer *),
     TRAIN_OUTPUT_LAYER2(layer *,layer *);

extern float neta,momentum;

void init_train_BACKPROP2(void)
{int i;
 strcpy(parameters.dirmask,"*.dat");
 reset = FALSE;
 if(!parameters.READY) return;
 init_net(parameters);
 loopi(parameters.layers){
	   net->layer1[i]->updater = TRAIN_LOWER_LAYER2;
	   net->layer1[i]->eta[0] = 1.0;
	   net->layer1[i]->eta[1] = momentum;}
	   net->layer1[parameters.layers-1]->updater = TRAIN_OUTPUT_LAYER2;
 loopi(parameters.layers)net->layer1[i]->propagate = calcy;
}


void TRAIN_OUTPUT_LAYER2(layer *l_on,layer *l_up)
{  if(l_up == NULL);
   dely(l_on->output,net->doft,l_on->delta,l_on->size_output);
   adjust_weights2(l_on);}


void TRAIN_LOWER_LAYER2(layer *l_on,layer *l_up)
{     delx(l_on->output,l_up->delta,l_on->delta,
	      l_up->weights,l_up->size_output,l_up->size_input);
      adjust_weights2(l_on);

}

void adjust_weights2(layer *l_on)
{ int i,j;
  float eta,moment;

  eta    = l_on->eta[0]/(float)l_on->size_input;
  moment = l_on->eta[1];

  loopj(l_on->size_output) {
    l_on->theta[j] =  l_on->theta[j] + eta * l_on->delta[j] ;
    loopi(l_on->size_input) {
       l_on->momentum[j][i] = (eta * l_on->delta[j] * l_on->input[i]
				 + moment * l_on->momentum[j][i]);
      l_on->weights[j][i] += l_on->momentum[j][i];}}}

