/*************************************************************************
*
*       DATE: 28 April 1990
*       VERSION: 2
*
*       NAME: Module for Conjugate Gradient Backprop
*       MODULE NUMBER: 1.6
*       DESCRIPTION: Using output, adjusts wights reduce error.
*       ALGORITHM: Werbos Multilayer Perceptron Backpropagation.
*       PASSED VARIABLES: None
*       RETURNS: None
*       GLOBAL VARIABLES USED: Weight Vectors
*       GLOBAL VARIABLES CHANGED: Weight Vectors
*       FILES READ: None
*       FILES WRITTEN: None
*       HARDWARE INPUT: None
*       HARDWARE OUTPUT: None
*       MODULES CALLED: None
*       CALLING MODULES: Main Loop
*
*       AUTHOR: Gregory L. Tarr
*       HISTORY:
*
*************************************************************************/

#include <defines.h>
#include <math.h>
#include <stdlib.h>

extern nnet *net;

extern setup parameters;

#define FABS(A) (((A)>0.0)?(A):(-(A)))
#include "percp\bp.h";

void TRAIN_LOWER_LAYER4(layer*,layer*),
     TRAIN_OUTPUT_LAYER4(layer*,layer*);
void gamx(float *,float *,float *,float *,float **,int,int);
void gamy(float *,float *,float *,int);

extern void TRAIN_NULL(layer*,layer*);

extern int reset;
extern int neta,momentum;

void init_train_BRAIN(void )
{int i;
  reset = FALSE;
 if(!parameters.READY) return;
 momentum = 0.0;
 init_net(parameters);
 loopi(parameters.layers){
	      net->layer1[i]->updater = TRAIN_LOWER_LAYER4;
	      net->layer1[i]->eta[0] = 1.0;
	      net->layer1[i]->eta[1] = 0.7;}
	   net->layer1[parameters.layers-1]->updater =TRAIN_OUTPUT_LAYER4;
           loopi(parameters.layers)
              net->layer1[i]->propagate = calcy;


}


void TRAIN_OUTPUT_LAYER4 (l_on,l_up)
layer *l_on,*l_up;
{ int i,j,k,lower,upper;
  float nmu,momentum;

  nmu     = l_on->eta[0];
  momentum = l_on->eta[1];
  if(l_up == NULL);
dely(l_on->output,net->doft,l_on->delta,l_on->size_output);
gamy(l_on->output,net->doft,l_on->gamma,l_on->size_output);

loopj(l_on->size_output) {
    l_on->deltheta[j] = l_on->delta[j]/(nmu+FABS(l_on->gamma[j]))
                          + momentum*l_on->deltheta[j];
    l_on->theta[j] += l_on->deltheta[j];
    loopi(l_on->size_input) {
      l_on->momentum[j][i] =
          ( l_on->delta[j]*l_on->input[i] /
		(nmu+FABS(l_on->input[i]*l_on->input[i]*l_on->gamma[j]))
				 + momentum * l_on->momentum[j][i] );
      l_on->weights[j][i] += l_on->momentum[j][i];
	       }}
}
void TRAIN_LOWER_LAYER4(layer *l_on,layer *l_up)
{ int i,j,k;
  float nmu,momentum;
  nmu = l_on->eta[0];
  momentum = l_on->eta[1];

  delx(l_on->output,l_up->delta,l_on->delta,
	      l_up->weights,l_up->size_output,l_on->size_output);
  gamx(l_on->output,l_on->delta,l_up->gamma,l_on->gamma,
	      l_up->weights,l_up->size_output,l_on->size_output);

  loopj(l_on->size_output) {
    l_on->deltheta[j] = l_on->delta[j]/(nmu+FABS(l_on->gamma[j]))
                          + momentum*l_on->deltheta[j];
    l_on->theta[j] += l_on->deltheta[j];
    loopi(l_on->size_input) {
      l_on->momentum[j][i] =
          ( l_on->delta[j]*l_on->input[i] /
		(nmu+FABS(l_on->input[i]*l_on->input[i]*l_on->gamma[j]))
				 + momentum * l_on->momentum[j][i] );
      l_on->weights[j][i] += l_on->momentum[j][i];
      }};
}

void gamy(float *y,float *doft,float *gamma,int output)
 { int i;
   loopi(output) gamma[i] = -(y[i]*(1.0-y[i]))*(doft[i]-y[i])*(1.0-2*y[i])
                            + y[i]*(1.0-y[i]) * y[i]*(1.0-y[i]); }

void gamx(float *x,float *del_down,float *gamma,
float *gamma_down,float **w,int upper,int lower)
 { float sum;
   int i,j;
loopj(lower){
   sum = 0.0;
   loopi(upper) { sum += gamma[i] * w[i][j]*w[i][j];}
   gamma_down[j] = (1.0-2*x[j])*del_down[j]
		   + x[j]*(1.0-x[j])*x[j]*(1.0-x[j])*sum;}
   }


