/*************************************************************
*							     *
*  Program: Neural Net Simulator			     *
*							     *
*  Author: Greg Tarr                  Date:19 May 1990       *

*  NAME: Function Approximation with Backprop with momentum
*  MODULE NUMBER: 1.6
*  DESCRIPTION: Using output, adjusts wights reduce error.
*  ALGORITHM: Werbos Multilayer Perceptron Backpropagation.
*							     *
*  Module: 						     *
*  SubModules:                                               *
*  Super Module: title.c                                     *
**************************************************************/

#include <defines.h>
#include <math.h>

extern nnet *net;

extern setup parameters;

extern float calcy(),calcy_linear();
extern int reset;

void TRAIN_OUTPUT_LAYER5();

extern void TRAIN_LOWER_LAYER2();

extern float neta,momentum;

init_train_BACKPROP5()

{int i;
 parameters.sencode = VECTOR;
 strcpy(parameters.dirmask,"*.vec");
 reset = FALSE;
 if(!parameters.READY) return;
 init_net(parameters);
 loopi(parameters.layers){
	   net->layer1[i]->updater = TRAIN_LOWER_LAYER2;
	   net->layer1[i]->propagate = calcy;
	   net->layer1[i]->eta[0] = neta;
	   net->layer1[i]->eta[1] = momentum;}

	   net->layer1[parameters.layers-1]->eta[0] = 0.05;
	   net->layer1[parameters.layers-1]->updater = TRAIN_OUTPUT_LAYER5;
	   net->layer1[parameters.layers-1]->propagate = calcy_linear;

}


void TRAIN_OUTPUT_LAYER5(layer *l_on,layer *l_up)
{ int i,j,k,lower,upper;
  float neta,momentum;

  neta     = l_on->eta[0]/(float)l_on->size_input;
  momentum = l_on->eta[1];
  if(l_up);/* does nothing except defeat a compiler warning */
dely_linear(l_on->output,net->doft,l_on->delta,l_on->size_output);

loopj(l_on->size_output) {
    l_on->theta[j] =  l_on->theta[j] + neta * l_on->delta[j] ;
    loopi(l_on->size_input) {
       l_on->momentum[j][i] = (neta * l_on->delta[j] * l_on->input[i]
				 + momentum * l_on->momentum[j][i]);
      l_on->weights[j][i] += l_on->momentum[j][i];

               }}
}


dely_linear(float *y,float *doft,float *del,int output)
	    /* computer error vector for output           */
	    /* Interface requires computed output         */
	    /* Desired output and storage for error: del. */
 { int i;loopi(output){ del[i] = (doft[i]-y[i]);}}
