/*************************************************************
*							     *
*  Program: Neural Net Simulator			     *
*							     *
*  Author: Greg Tarr                  Date:19 May 1990       *
*							     *
*  Module: display routines   				     *
*  SubModules:                                               *
*  Super Module: percp.c title.c                             *
**************************************************************/

/* these display routines are dependent upon on having an
EGA or VGA display and a Turbo C compiler */

#include <stdio.h>
#include <graphics.h>
#include <defines.h>

#define node_spc  64
#define layer_spc 35
#define layer_up  50

extern char netcon[];
extern int ctype,sample,called,winnerx;
extern float class_err,alpha,neigh;
extern nnet *net;
extern setup parameters;


char the_name[80];
int do_display = TRUE;

DISPLAY_SCREEN()

{ int i,j,k,x,y;char junk[80];
show_memory();
sprintf(junk,"Desired");
loopi(parameters.output)
{place_node(net->outp[i],(node_at_x(i,parameters.output)),40);
 place_node(net->doft[i],(node_at_x(i,parameters.output)),18);}
settextstyle(2,0,2);

loopi(parameters.layers) {
	  loopj(net->layer1[i]->size_input)
	      { put_node(i,j,net->layer1[i]->size_input,
			  net->layer1[i]->input,4);}
	    draw_layer_weights(i);
	      }
 setcolor(YELLOW);
 outtextxy(-30+node_at_x(parameters.output,parameters.output),
	       28,junk);
 outtextxy(-30+node_at_x(parameters.output,parameters.output),
	       50,"Actual");
show_config();
}

place_node(valuex,x,y)
float valuex;int x,y;
{  char junk[30];
   settextstyle(SMALL_FONT,0,4);
   if(valuex > 0.5) setfillstyle(SOLID_FILL,RED);
      else setfillstyle(SOLID_FILL,BLUE);
   bar(x,y,x+40,y+10);
   sprintf(junk,"% 3.2f",valuex);
       outtextxy(x+1,y,junk);
}

show_memory()
{ char junk[80];
  unsigned int left;
  left = coreleft();
  sprintf(junk,"Memory Left:%u ",left);
  setfillstyle(SOLID_FILL,BLACK);
  bar(20,202,200,210);
  setcolor(CYAN);
  outtextxy(25,202,junk);

}

#define scn_max 639;
node_at_x(int node,int number)
/* node : actual node number
   number: total number in layer.
                                          */
{  int x;
   int node_spacing = node_spc;
   if(number > 9) node_spacing *= 0.3;
   if (number > 32) number = 32;
   x=(639 - number * node_spacing)/2 + node * node_spacing+5;

   return x;
}

node_at_x_square(int node,int number)
{  int x;
   int node_spacing = node_spc;
   node_spacing *= 0.3;
   if (number > 32) number = 32;
   x=(639 - number * node_spacing)/2 + node * node_spacing+5;
   return x;
}

show_key()
{
int i;

loopi(16) {  setfillstyle(i,i);
 bar(i*15+20,20,i*15+30,30);
    }
}
fill_case(float nx)
{ int n;
  n=(int)(nx * 5.0+0.1);
  switch(n){
  case 0:setfillstyle(1,1);break;
  case 1:setfillstyle(9,1);break;
  case 2:setfillstyle(11,1);break;
  case 3:setfillstyle(11,4);break;
  case 4:setfillstyle(9,4);break;
  case 5:setfillstyle(1,4);break;
               }

}
#define issquare(layerx) net->layer1[layerx]->square

node_at_y(int layerx)
{  return  180 - layerx*130/parameters.layers  ; }

node_at_y_square(layerx,lay,lays)int layerx,lay,lays;
{  return  180 - layerx*130/parameters.layers + 10 * lay - lays*5 ; }

put_node(int layerx,int node,int number,float *n_node,int fsize)
{ int x,xi,y,yi,lay;
  char junk[20];
  setcolor(WHITE);

if((issquare(layerx) > 0)&layerx < parameters.layers){
		  y= node_at_y_square(layerx,node/issquare(layerx),
				      issquare(layerx));
		  x = node_at_x_square(node%issquare(layerx),
				       issquare(layerx));
				       setfillstyle(1,
				       (int)net->layer1[0]->theta[node]);
				       bar(x-5,y-2,x+6,y-10);
		    if(node == winnerx)rectangle(x-5,y-2,x+6,y-10);
				       return;

				       }

if(node > 32 ) return;
    y=node_at_y(layerx);
    x=node_at_x(node,number);



  if(!((x>620)|(x<20))) {

{if(n_node[node] < 0) setfillstyle(1,BLUE);
	 else setfillstyle(1,RED);}


fill_case(n_node[node]);

if(number < 10){
  bar(x-5,y,x+48,y-15);
  setcolor(YELLOW);
  sprintf(junk,"% 1.2f",n_node[node]);
  settextstyle(SMALL_FONT,0,fsize);
  outtextxy(x+6,y-12,junk);}
else
 bar(x-5,y-2,x+6,y-10);
  sprintf(junk,"%d",node);
  setcolor(CYAN);
  settextstyle(SMALL_FONT,0,3);
if(number < 10)  outtextxy(x,y-12,junk);
   else outtextxy(x-4,y-11,junk);

   }


}
show_config()
{    char junk[80];
      settextstyle(SMALL_FONT,0,4);
     if(strlen(the_name)==0) return;
     setviewport(0,0,639,349,1);
     setcolor(CYAN);
     setlinestyle(SOLID_LINE,0,1);
     aboxer(250,190,the_name,CYAN,YELLOW,YELLOW);
     setcolor(WHITE);
     outtextxy(525,205,parameters.file);
     sprintf(junk,"Class: %2d Sample:%2d",ctype,sample);
     aboxer(20,180,junk,CYAN,RED,BLUE);

}

draw_layer_weights(int k)
{ int i,j,layer_upx,layer_down;complex rng={0.0,0.0};
   char junk[80];
  layer_down = net->layer1[k]->size_input;
  layer_upx   = net->layer1[k]->size_output;

  if(net->layer1[k]->square > FALSE) return;
  if(k != parameters.layers-1)
  {if((net->layer1[k+1]->square > FALSE)&(k<parameters.layers)) return;}

  if(layer_down > 32) {sprintf(junk,"%d more...",layer_down-32);
		       layer_down = 32;

	setcolor(YELLOW);outtextxy(580,node_at_y(k),junk);}

if(layer_upx > 32) layer_upx = 32;
loopj(layer_upx){
 loopi(layer_down)  {
       set_scale(net->layer1[k]->weights[j][i]);
       moveto(node_at_x(i,net->layer1[k]->size_input),
	      node_at_y(k)-15);
       lineto(node_at_x(j,net->layer1[k]->size_output),
	      node_at_y(k+1)+1);}}
max_weights(k,net->layer1[k],&rng);
}
set_scale(value)
float value;
{int lx;

 if (value < 0.){ setcolor(BLUE);
                 value= -value;}
          else setcolor(RED);
 if(value < 0.02){ setcolor(DARKGRAY); return 0;}
 if(value > 4.0){ setlinestyle (1,0,1);return 0;}
 if(value > 3.0){ setlinestyle (1,1,1);return 0;}
 if(value > 2.0){ setlinestyle (1,2,1);return 0;}
 if(value > 1.0){ setlinestyle (1,3,1);return 0;}

}
int dwidex;

display_report(int i)
{ int x,y;
   char junk[20];

   setfillstyle(1,0);

   switch(parameters.sencode){
   case BINARY:
   case CLASS:  dwidex = 30;
		setcolor(YELLOW);x = 80+ i*16;         y=220;
if(i>(dwidex))  {setcolor(WHITE);x = 80+(i-dwidex)*16;    y=230;}
if(i>(dwidex*2)){setcolor(CYAN) ;x = 80+(i-(dwidex*2))*16;y=240;}

if(i<(dwidex)) bar(x-5,y,x+25,y+90);
	 sprintf(junk,"%d",i); outtextxy(x,y,junk);
	 sprintf(junk,"%d",ctype);outtextxy(x,y+30,junk);
	 sprintf(junk,"%d",called);outtextxy(x,y+60,junk);break;
case VECTOR:  dwidex = 8;
setcolor(YELLOW);x = 80 + i*40;y = 220;
if(i>(dwidex)  ){setcolor(WHITE);x=80+(i-dwidex)*40;    y=230;}
if(i>(dwidex*2)){setcolor(CYAN); x=80+(i-(dwidex*2))*40;y=240;}

	 if(i<=(dwidex)) bar(x-5,y,x+35,y+90);
	 sprintf(junk,"%d",i); outtextxy(x,y,junk);
	 sprintf(junk,"%3.1f",class_err);outtextxy(x,y+60,junk);break;
			     }

}
extern float err;
write_stats(x,y,right,good,string,number)
int x,y,right,good;
char string[];
int number;
{ char junks[80];
  setlinestyle(0,0,1);
  sprintf(junks,"%s: Right %3.2f Good %3.2f Err %3.2f",string,
		    (float)right/(float)number*100.,
		    (float)good/(float)number*100.,err);
   setcolor(CYAN);
   shadowbox(x,y,x+260,y+15);
   outtextxy(x+10,y+3,junks);
   right = 0;  good = 0;
}

file_window(int x,int y){
setviewport( x,y,x+150,y+100,1);
clearviewport();
setcolor(RED);
boxviewport();}
restore_viewport(){ setviewport(0,0,639,349,1);}

boxviewport()
{
struct viewporttype vp;
getviewsettings(&vp);
rectangle(0,0,vp.right-vp.left,vp.bottom-vp.top);


}

int wide2,high2;

char get_string(x,y,offset,number,astring,initx,colorb,colorf)
char *astring,*initx; int x,y,offset,number,colorb,colorf;
{   int first,x1,y1;
       setcolor(YELLOW);
       setfillstyle(SOLID_FILL,BLUE);
       wide2 = number * textwidth(" ");
       high2 = textheight(" ");
       x1=x+offset;
       y1 = y;
       barit;
       strcpy(astring,initx);
       bartext(astring);
       fflush(stdin);
       first = getch();
       if(!is_control(&first)){ int cnt=1;
		    astring[0] = first;
		    astring[1] = 0;
		    while(TRUE){int x2;
			barit;
			bartext(astring);
			astring[cnt] = getch();

			astring[cnt+1] = 0;
			if((astring[cnt] == 13)|
			   (astring[cnt] == 0) |
			   (astring[cnt] == ESC)) break;
			if(astring[cnt] == 8) {cnt = cnt-1;
					 if(cnt < 0) cnt = 0;
					 astring[cnt] = 0;}
			else {if(cnt < number) cnt++;
			}
		      if(!strcmp(astring,"quit"))exit(0);

			}
			if(astring[cnt]==ESC)return ESC;
			astring[cnt] = 0;
			putit(astring,colorf,colorb,x1,y1);
			return 0;}

			putit(astring,colorf,colorb,x1,y1);
			return first;

}
putit(astring,colorf,colorb,x1,y1)
char *astring;
int colorf,colorb,x1,y1;
{
setcolor(colorf);
setfillstyle(SOLID_FILL,colorb);
barit;
bartext(astring);}

is_control(number)
int *number;
{
 if (*number == RETURN)    return TRUE;
 if (*number == ESC)   return TRUE;
 if (*number == 0) {*number = getch();return TRUE;}
 return FALSE;}

#define Ex 460
#define Ey 300
float maxhistory();

show_error(float *history,int indx)
{ int i;float xx,x2,HISTORY;

  HISTORY=history[0];

  graph_screen();


setlinestyle(0,1,3);setcolor(RED);

loopi(indx+1){ x2 = history[i]/HISTORY;
   if(x2 > 1.4) x2 = 1.4;
    xx =(float)Ey-(x2)*50.;
    draw(Ex+1+i*2,Ey-2,Ex+1+i*2,(int)xx);}


write_float((Ex+HIS_SIZE*2-30),(Ey-75),HISTORY);
write_float(Ex+HIS_SIZE*2-30,(Ey-5),history[indx]);

}
graph_screen()
{
   restore_viewport();
   setfillstyle(SOLID_FILL,BLUE);
   bar(Ex-1,Ey,Ex+(HIS_SIZE*2)+2,Ey-70);
   setfillstyle(HATCH_FILL,BLUE);
   bar(Ex-1,Ey,Ex+(HIS_SIZE*2)+2,Ey-70);
   setcolor(CYAN);
   rectangle(Ex-1,Ey,Ex+(HIS_SIZE*2)+2,Ey-70);
   setfillstyle(SOLID_FILL,CYAN);setlinestyle(0,0,1);
   aboxer(Ex+30,Ey-96,"Error History",LIGHTRED,BLUE,BLUE);

}

float maxhistory(float *history,int indx)
{int i;
float max = history[0];
loopi(indx) {if(history[i] > max){max = history[i]; }
	     }
return max;



}
draw(int x1,int y1,int x2,int y2){ moveto(x1,y1);lineto(x2,y2);}

write_float(x,y,val)
int x,y;
float val;
{ char junk[20];
  int wdth;
setcolor(YELLOW);
setfillstyle(SOLID_FILL,LIGHTRED);
sprintf(junk,"% 3.2f",val);
wdth = textwidth(junk);
bar(x-1,y+1,x+wdth,y+8);
outtextxy(x,y-1,junk);

}
shadowbox(x,y,x2,y2)
int x,y,x2,y2;
{
  setfillstyle(SOLID_FILL,MY_BLACK);
  bar(x+8,y+6,x2+8,y2+6);

  setfillstyle(SOLID_FILL,0);
  bar(x,y,x2,y2);
  rectangle(x,y,x2,y2);

}


/*  Following code relates to the title screen */

make_screenx()
{ restore_viewport();
  make_cover();
  shadowtext(120,120,3,"Neural Network Simulator");
  settextstyle(2,0,5);
  setcolor(CYAN);
  shadowbox(20,210,610,300);
  settextstyle(2,0,4);
  outtextxy(200,317,"Make Selection:");
  setcolor(YELLOW);
  outtextxy(400,320,"Written by Greg Tarr and Kevin Priddy");



}
make_cover()
{
  setlinestyle(SOLID_LINE,0,1);
  setfillstyle(SOLID_FILL,DARKGRAY);
  bar(0,0,639,349);
  setcolor(CYAN);
  rectangle(5,5,630,345);
  rectangle(1,1,639,349);

  setfillstyle(SOLID_FILL,MY_BLACK);

 bar(30+10,20+10,370+10,60+10);

  setfillstyle(11,BLUE);
  bar(30,20,370,60);
 setcolor(WHITE);rectangle (30,20,370,60);
 setcolor(CYAN) ;rectangle (30,20,370,60);
 shadowtext(60,20,4," NeuralGraphics");


}

shadowtext(x,y,size,item)
int x,y,size;
char *item;
{ settextstyle(1,0,size);
  setcolor(BLUE);
  outtextxy(x,y,item);
  setcolor(LIGHTGRAY);
  outtextxy(x-2,y+2,item);
 }
max_weights(int k,layer *l_on,complex *rng)
{ int i,j;

rng->r  = l_on->weights[0][0];

loopi(l_on->size_output) {
 loopj(l_on->size_input) {
    if(rng->r > l_on->weights[i][j]) rng->r = l_on->weights[i][j];
    if(rng->i < l_on->weights[i][j]) rng->i = l_on->weights[i][j];
 }}
settextstyle(SMALL_FONT,0,4);
write_float(210,node_at_y(k)-30, rng->r);
write_float(380,node_at_y(k)-30, rng->i);
}