/*************************************************************
*							     *
*  Program: Neural Net Simulator			     *
*							     *
*  Author: Greg Tarr                  Date:19 May 1990       *
*							     *
*  Module:Help file. Provides a help utility		     *
*  SubModules:help.doc - the actual ascii data               *
*  Super Module: title.c                                     *
**************************************************************/

#include <stdio.h>
#include <string.h>
#include <graphics.h>
#include <ctype.h>
#include <dir.h>
#include <ascii.h>
#include <defines.h>
FILE *Hfp;
#define htop 15
#define hleft 15
int hbot = 320;
#define hright 622
#define QUIT -1
#define CONTINUE -2
#define TRUE 1
extern float neta,momen,alpha;
extern int display,reset;
int leftmargin=10,rightmargin=530,topmargin=0,bottommargin=280;
int tsec=0,tsubsec=0,tsubsubsec=0;
extern int continx;
char currdir[80];
extern char *curwdir;
char do_help(helpfile)
char *helpfile;
{
  reset_directories();
  chdir("help");
  getcwd(currdir,80);

  Hfp = fopen(helpfile,"ra");

  if(Hfp == NULL) {printf("Current Directory %s ",currdir);return 0;}
  reset_directories();
  setviewport(hleft,htop,hright,hbot,1);
  clear_page();
  /* Now go out and read file  */
  return reader();

}
restore_after()
{
  percp_scn();
  DISPLAY_SCREEN();
}

reader()
{ int i,j,k;
  char word[80];
  int letter;
  i = 0;
  tsec=1;tsubsec=0;tsubsubsec=0;
  while(TRUE){

  letter = fgetc(Hfp);
  if(letter == EOF) {return getch();}
  switch(letter){
      case '{': command(word);strcpy(word,"");i=0;fgetc(Hfp);break;
      case '!': outtext(word);newline(0);strcpy(word,"");
		fgetc(Hfp);i=0;break;
      case '\\':i=0;
      case 10:  if(i==0){newline(20);break;}

      case ' ': if((getx()+strlen(word)*6)>rightmargin)
		if(newline(0)==QUIT) return ESC;
		outtext(word);
	        i=0;letter = ' ';
      default:  if (letter > 127) break;
		word[i] = (unsigned char) letter;
                word[i+1] = 0;
	        i++;
		break;}
  }
}

int colorx;

#define wordcase(WORD) if(!strcmp(word,WORD))
#define Cchapter strcpy(word,"chapter")

command(word)
char word[];
{ char junk[80],section_numb[80];
  int letter;

 wordcase("section"){tsec++;tsubsec=0;Cchapter;}
 wordcase("subsection"){tsubsec++;tsubsubsec=0;strcpy(word,"chapter");}
 wordcase("subsubsection"){tsubsubsec++;Cchapter;}


wordcase("chapter") { style_one();newline(1);
		      if((tsubsubsec == 0) & (tsubsec == 0))
		      sprintf(section_numb,"%d. ",tsec);
		      if((tsubsec !=0)&(tsubsubsec == 0))
		      sprintf(section_numb,"%d.%d ",tsec,tsubsec);
		      if((tsubsec != 0)&(tsubsubsec !=0))
	  sprintf(section_numb,"%d.%d.%d ",tsec,tsubsec,tsubsubsec);

	  outtext(section_numb);
	  while(TRUE){letter=fgetc(Hfp);
            junk[0]=(unsigned char) letter;
	    junk[1]=0;
               if(letter != '}') outtext(junk);
		    else break;}
		    newline(0);newline(0);
		    }

wordcase("leftmargin"){
         fscanf(Hfp,"%d",&leftmargin);fgetc(Hfp);}

wordcase("rightmargin"){
         fscanf(Hfp,"%d",&rightmargin);fgetc(Hfp);}
wordcase("color"){
         fscanf(Hfp,"%d",&colorx);fgetc(Hfp);
	 setcolor(colorx);}
wordcase("page"){ moveto(1,bottommargin);do_page();fgetc(Hfp);}

wordcase("author") {strcpy(word,"title");}


wordcase("title") {
	  style_three();
	  newline(0);
	  do_word(junk);
	  center(junk);newline(0);		    }

wordcase("smalltitle") {
	  style_four();
	  newline(0);
	  do_word(junk);
	  center(junk);}

wordcase("bullet") {
	  newline(0);
	  do_word(junk);
	  setcolor(WHITE);
	  outtextxy(40,gety(),"*");
	  setcolor(colorx);
	  outtextxy(80,gety(),junk); }
wordcase("line") {newline(0);};

style_two();

}
do_slides(){}

do_word(aword)
char aword[];
{ int letter,i;
  i=0;
  while(TRUE)
	{letter=fgetc(Hfp);
	if(letter == '}') break;
        aword[i]=(unsigned char) letter;
	aword[i+1]=0;
        i++;if(i>78)break;
	       }}
center(junk)
char junk[];
{outtextxy((hright-hleft)/2-strlen(junk)*7,gety(),junk);

}

style_one()
{
   setcolor(RED);
   settextstyle(1,0,3);}
   style_two()
{
  setcolor(colorx);
  settextstyle(0,0,1);}

style_three()
{ setcolor(WHITE);
  settextstyle(1,0,2);}

style_four()
{ setcolor(BLUE);
  settextstyle(1,0,1);}

newline(indent)
int indent;
{moveto(leftmargin+indent,gety()+12);
 do_page();}

do_page()
{      if(gety()< bottommargin-10) return 0;
	     style_two();
	     setcolor(BLUE);
	     outtextxy(150,bottommargin+15,
		     "<Space> to continue <q> to exit Help ");
                               style_two();
			    switch(getch())
			       {case ESC:
				case 'q': return QUIT;
			        case ' ': break;}
	  clear_page();
	  moveto(leftmargin,topmargin+20);
	  return CONTINUE;
}

clear_page()
{ int cx;
  slines;
  cx = getcolor();
  setfillstyle(1,LIGHTGRAY);
  bar(0,0,hright-hleft,hbot-htop);
  setcolor(RED);
  rectangle(0,0,hright-hleft,hbot-htop);
  rectangle(5,5,hright-hleft-5,hbot-htop-15);
  setcolor(cx);
  outtextxy(10,10,currdir);
 }



boxdata(x,y,title,value)
int x,y;
char title[];
float value;
{ char junk[40],title2[40];
sprintf(junk,"%3.3f   ",value);
strcpy(title2,title);
strcat(title2,junk);
aboxer(x,y,title2,BLUE,CYAN,YELLOW);
}
iboxdata(x,y,title,value)
int x,y;
char title[];
int value;
{ char junk[40],title2[40];
sprintf(junk," %3d   ",value);
strcpy(title2,title);
strcat(title2,junk);
aboxer(x,y,title2,BLUE,CYAN,YELLOW);
}
void license(){reset = TRUE;
		do_help("license.doc");}
void tutorial(){reset = FALSE;
	   switch(do_help("helpm.doc"))
	      { case '1': do_help("getst.doc");break;
				/* Getting Started             */

		case '2': do_help("help1.doc");break;
				/* Full   Tutorial             */

		case '3': do_help("backprop.doc");break;
				/* BackPropagation   */

		case '4': do_help("sales.doc");break;
				/* BackPropagation   */

		case '5': do_help("hopfield.doc");break;
				/* BackPropagation   */

		case '6': do_help("hopfield.doc");break;
				/* BackPropagation   */

		case '7': do_help("compgam.doc");break;
				/* Computer Gambling  */

		case '8': do_help("datapre.doc");break;
		      /* Data Preparation files */

		case 'a': do_help("bam.doc");break;}

		       reset = TRUE;}

/* Help from title screen */
void HELP(){do_help("main.doc");reset = TRUE;}
