/*************************************************************
*                                                            *
*  Program: Neural Net Simulator                             *
*                                                            *
*  Author: Greg Tarr                  Date:19 May 1990       *
*                                                            *
*  NAME: Module for hybrid                                   *
*  MODULE NUMBER: 1.6                                        *
*  DESCRIPTION: Using output, adjusts wights reduce error.   *
*  ALGORITHM:   Variation on Hybrid propagation              *
*                                                            *
*  Module: Hybrid.c                                          *
*  SubModules:  none...                                      *
*  Super Module: title.c                                     *
**************************************************************/

#include <math.h>
#include <stdio.h>
#include <defines.h>
#include "percp\bp.h"
extern nnet *net;

extern int neta,momentum;
extern setup parameters;

float calck(layer *,int), fixk(float ,float);

void TRAIN_HYBRID_LAYER(layer *,layer *);

extern int reset;

void init_train_HYBRID(void)
{int i;
 strcpy(parameters.dirmask,"*.dat");
 reset = FALSE;
 if(!parameters.READY) return;
 init_net(parameters);
 loopi(parameters.layers){
		net->layer1[i]->updater = TRAIN_NULL; // TRAIN_LOWER_LAYER2;
		net->layer1[i]->eta[0] = 0.4 ;
		net->layer1[i]->eta[1] = 0.7 ;  }

 net->layer1[parameters.layers-1]->updater = TRAIN_NULL;//TRAIN_OUTPUT_LAYER2;
	     loopi(parameters.layers)
		net->layer1[i]->propagate = calcy;

	net->layer1[0]->updater = TRAIN_NULL;// TRAIN_HYBRID_LAYER;
	net->layer1[0]->propagate = calck;


}

void TRAIN_HYBRID_LAYER(layer *l_on,layer *l_up)
{ int i,j,k,lower,upper,maxi;
  float neta;
   neta = l_on->eta[0] *= 0.99;
   delx(l_on->output,l_up->delta,l_on->delta,
	      l_up->weights,l_up->size_output,l_on->size_input);

  loopj(l_on->size_output) { float xx;
   loopi(l_on->size_input) {
     l_on->momentum[j][i] = -(neta * l_on->delta[j] *
				  (l_on->input[i] - l_on->weights[j][i]));
      l_on->weights[j][i] += l_on->momentum[j][i];


	       }}
}

float calck(layer *l_on,int number)
 {int i,k;
   float y,xx;

   y = 0.0;
   loopi(l_on->size_input){xx = l_on->input[i]-l_on->weights[number][i];
		y  += (xx*xx);}
		;
   return fixk(y,1.0);}

float fixk(float y,float hard)

{return 1.0/(hard+y);}


