/*************************************************************
*							     *
*  Program: Neural Net Simulator			     *
*							     *
*  Author: Greg Tarr                  Date:19 May 1990       *
*							     *
*  Module: Initialize   				     *
*  SubModules: paradigms                                     *
*  Super Module: title.c                                     *
**************************************************************/
/******Includes ***********/
#include <graphics.h>
#include <stdlib.h>
#include <stdio.h>
#include <defines.h>
#include <math.h>
#include <string.h>
#include <alloc.h>
#include <ascii.h>
#include <dir.h>
/************************/

float randomy();
extern nnet *net;
extern ITEMS items[];
setup parameters;
float *MALLOC_FILL(),**DMALLOC_FILL();

extern void TRAIN_NULL();
extern float calcy();
extern int indx;

do_direc(char *dmask)
{ struct viewporttype c;
  struct ffblk dirblk;
  char wwdir[80];
  int done,i=0,x,y;
  getviewsettings(&c);
  setviewport(0,0,639,349,1);
  settextstyle(SMALL_FONT,0,4);
  setcolor(CYAN);
  shadowbox(250,80,550,177);
  getcwd(wwdir,80);
  outtextxy(260,90,wwdir);
  done = findfirst(dmask,&dirblk,0);
  setcolor(WHITE);
  while(!done){
       x = i % 5;
       y = i/5;
       outtextxy(260+y*70,105+x*15,dirblk.ff_name);
       done=findnext(&dirblk);
       i++;
       }
  setviewport(c.left,c.top,c.bottom,c.right,c.clip);


}

init_net(setup p)
{ int i,j,k;  float *ainput;
  int input,output,hide[10];
  input = p.input;
  output = p.output;
  loopi(5){hide[i+1] = p.hide[i];}
  hide[0] = input;hide[p.layers] = output;/* size of inputs stored
					     sequentially;         */
  if(net != NULL)  {free_net();}
  MALLOC(net,nnet,1,"net ");
  MALLOC(net->inp,float,input,"Input node");
  MALLOC(net->doft,float,output,"doft_node");FILL(net->doft,0.0,output);
  loopi(p.layers){
      MALLOC(net->layer1[i],layer,1,"layer ");}
  loopi(p.layers) allocate_layer(i,hide[i],hide[i+1]);
  loopi(p.layers) CONNECT(net->layer1[i],net->layer1[i+1]);

  CONNECT_INPUT(net->layer1[0]);
  CONNECT_OUTPUT(net->layer1[p.layers-1]);
  loopi(parameters.input) net->inp[i]= 0.0;
  indx = 0;
}

CONNECT_INPUT(t_input)
layer *t_input;
{  t_input->input = net->inp; }

CONNECT_OUTPUT(t_output)
layer *t_output;
{net->outp = t_output->output;
}
CONNECT(t_input,t_output)
layer *t_input,*t_output;
{    t_output -> input  = t_input->output;   }

check_malloc(point,caption)
float *point;
char caption[];
{
if(point == NULL){ printf("Memory Allocation Error in %s\n",caption);exit(0);}
}

allocate_layer(the_layer,the_input,the_output)
int the_layer,the_input,the_output;
{ int i;

net->layer1[the_layer]->output = MALLOC_FILL(the_output,"output");
net->layer1[the_layer]->delta  = MALLOC_FILL(the_output,"delta " );
net->layer1[the_layer]->gamma     = MALLOC_FILL(the_output,"gamma " );
     FILL(net->layer1[the_layer]->gamma,0.0,the_output);
net->layer1[the_layer]->deltheta  = MALLOC_FILL(the_output,"deltheta " );
     FILL(net->layer1[the_layer]->deltheta,0.0,the_output);
net->layer1[the_layer]->theta   = MALLOC_FILL(the_output,"theta");
net->layer1[the_layer]->weights = DMALLOC_FILL(the_output,the_input,"weights");
net->layer1[the_layer]->momentum= DMALLOC_FILL(the_output,the_input,"momem");

net -> layer1[the_layer] -> size_input = the_input;
net -> layer1[the_layer] -> size_output = the_output;
net->layer1[the_layer]->square = 0;
	   net->layer1[the_layer]->updater = TRAIN_NULL;
	   net->layer1[i]->propagate = calcy;

}

free_net()
{int i;
loopi(parameters.layers) free_layer(i);
free(net->inp);
free(net->doft);
free(net);
net = NULL;
parameters.READY = FALSE;
}
free_layer(i)
int i;
{
free(net->layer1[i]->output);
free(net->layer1[i]->delta);
free(net->layer1[i]->gamma);
free(net->layer1[i]->deltheta);
free(net->layer1[i]->theta);

free_double(net->layer1[i]->weights,net->layer1[i]->size_output);
free_double(net->layer1[i]->momentum,net->layer1[i]->size_output);
free(net->layer1[i]);
}

free_double(float **storage,int amount)
{int i ;loopi(amount) free(storage[i]);
 free(storage);
 storage = NULL;}

extern void (* initialize_paradigm[])();
       void (* init_paradigm)();


init_train(){items[parameters.train_rule].place();}
/*
extern int continx;

init_item(rule)
int rule;
{ continx = TRUE;
  init_paradigm = items[rule].place;
  init_paradigm();}
  */


extern long int count;

#define checkESC if(dowhat==ESC);return ESC;

INITIALIZE(){

  open_setup_window();
  init_data_head_train_weights();
  close_setup_window();
  refresh_the_display();
}

refresh_the_display()
{ percp_scn();
  MAKE_INPUT(net->inp,net->doft,-1);
  DISPLAY_SCREEN();
  graph_screen();}

open_setup_window(){menu_windowx(16,16);clear_window();}
close_setup_window(){exit_menu();}

init_data_head_train_weights()
{int dowhat;
 parameters.READY = TRUE;
 count = 0;
 init_data();
 clear_window();
 init_head();
 init_train();
 init_weights();
 calculate_error();
 }

init_weights()
{  char filename[80];
		    do_direc("*.wei");
		    outtextxy(10,75,"Weight File  ?");
		    outtextxy(10,105,"r for random weights");
		    get_string(10,90,0,12,filename,"r",BLACK,YELLOW);
		    if(strlen(filename)>1) read_weights(filename);
		    else switch(filename[0])
		    { case 'r':break;
		      case 'n':outtextxy(12,70,"How Much Noise ?");
                               gotoxy(16,6);
			       scanf("%f",&parameters.add_noise);
			       break;}



}

float **DMALLOC_FILL(x,y)
int x,y;
{ int i,j;float **item;
item = (float **)calloc(sizeof(float *), x);
if(item == NULL){printf("First pointer Dalloc Error\n");exit(0);}
loopi(x){ item[i] = (float*)calloc(sizeof(float),y);
	if(item[i] == NULL) {printf("Dalloc allocation error ");
			     printf("error in %d ",i);exit(0);}}
loopi(x)loopj(y) item[i][j]= randomy();
return item;
}

float *MALLOC_FILL(x,what)
int x;
char what[];
{ float *item;int i;
item = (float *) calloc(sizeof(float),x);
if(item == NULL) {printf("Alloc %s  ",what);exit(0);}
FILL_RANDOM(item,x);

return item;
}

int *MALLOCI_FILL(int x,char *what)
{ int *item;int i,val;
item = (int *) calloc(sizeof(int),x);
if(item == NULL) {printf("Alloc %s  ",what);exit(0);}
loopi(x){ item[i]=0;}
return item;
}
