/*************************************************************
*							     *
*  Program: Neural Net Simulator			     *
*							     *
*  Author: Greg Tarr                  Date:19 May 1990       *
*							     *
*  Module: Kohonen Self-Organization Classifier              *
*  SubModules:                                               *
*  Super Module: title.c                                     *
**************************************************************/

#include <defines.h>
#include <math.h>
#include <stdio.h>

extern nnet *net;
extern long int count;
extern setup parameters;

extern float calcy();
float calck(),get_distance();
extern float hardness;
float neighborhood= 2.0;
int aside;
extern void TRAIN_LOWER_LAYER2(),
	     TRAIN_OUTPUT_LAYER2();
	     TRAIN_NULL();
       void TRAIN_KOH_LAYER();

extern int reset;

init_train_Kohon()

{int i,neighbor;
 strcpy(parameters.dirmask,"*.dat");
 reset = FALSE;
 if(!parameters.READY) return;
 aside = parameters.hide[0];
 parameters.hide[0] = aside*aside;
 neighborhood = (float)aside;
 init_net(parameters);

 net->layer1[1]->square = aside;
 loopi(parameters.layers){
                net->layer1[i]->updater = TRAIN_LOWER_LAYER2;
		net->layer1[i]->eta[0] = 0.6 ;
		net->layer1[i]->eta[1] = 0.7 ;
                                        }
	net->layer1[parameters.layers-1]->updater = TRAIN_OUTPUT_LAYER2;
         loopi(parameters.layers)
                net->layer1[i]->propagate = calcy;

	net->layer1[0]->updater = TRAIN_KOH_LAYER;
	net->layer1[0]->propagate = calck;

	loopi(parameters.hide[0])
		{ net->layer1[0]->theta[i] = 0.0;}

}
int winnerx;
void TRAIN_KOH_LAYER(l_on,l_up)
layer *l_on,*l_up;

{ int i,j,k,lower,upper,maxi,maxout;
  float neta=0.1,momentum;
  reset = FALSE;
  wait(100){ neighborhood *= 0.95;
	     net->layer1[0]->eta[0] *= 0.85;
	     gotoxy(62,6);printf("Neighborhood:%d",(int)neighborhood);
	     gotoxy(62,7);printf("Eta %3.3f ",net->layer1[0]->eta[0]); }
  maxi = maxfinder3(l_on->output,l_on->size_output);
  winnerx = maxi;
  maxout = maxfinder3(net->outp,parameters.output);
  l_on->theta[maxi]=maxout+4;

  loopj(l_on->size_output) { float distance,xx;
     distance = get_distance(maxi,j,l_up->square);
     if(distance < neighborhood ) xx = neta;
     else xx = neta/100.;
     loopi(l_on->size_input) {
     l_on->momentum[j][i] = (xx *
		 (l_on->input[i] - l_on->weights[j][i]));
	l_on->weights[j][i] += l_on->momentum[j][i];
	       }}
}

float get_distance(winner,present,neigh)
int winner,present,neigh;
{ int diff;

/*row difference*/

  diff = abs((int)(winner/neigh) - (int)(present/neigh))+
	 abs((winner % neigh) -(present %neigh));

 return diff;
}

maxfinder3(xarray,size_array)
float *xarray;
int size_array;
{
int i,maxi;
float maxf;
maxf = 0.0;
maxi = 0;
loopi(size_array) {if(xarray[i] > maxf){maxf = xarray[i];maxi = i;}}
return maxi;
      }

