/*************************************************************
*							     *
*  Program: Neural Net Simulator			     *
*							     *
*  Author: Greg Tarr                  Date:19 May 1990       *
*							     *
*  Module: Makeinput.c  				     *
*  SubModules: None. Package includes input file editor      *
*              and data normalization routines.              *
*  Super Module: title.c                                     *
**************************************************************/

#include <graphics.h>
#include <defines.h>
#include <string.h>
#include <stdio.h>
#include <math.h>
#include <ascii.h>
#include <dir.h>

int examplars, exam_test;
extern setup parameters;

int random_int();

float **data,**data_out;
int   *class;
char get_string();
float randomy();
extern float **DMALLOC_FILL();
extern int *MALLOCI_FILL();
int type_of_file = 0 ;
char filename[30]={"xor.dat"};
char dirname[30]={"data"};
FILE *fst,*fp;

char in_data[80] ={""};
extern char normal[][20];
#define lrand48 rand
#define checkESC if(gotdata==ESC)return ESC;


int true_output,binx[8]={1,2,4,8,16,32,64,128};

init_data()
{
 char aname[30],junkn[30];
 int j,k,maxi;
 float y,z,max,junk;
 FILE *fc;

  strcpy(aname,filename);
  clear_window();
  while(TRUE){
	get_file_name(aname);
	if(open_data_file(aname)){ load_data(aname);break;}
	     }
  do_preproc();
  do_normal();
  reset_directories();
}

get_normal(int *xx)
{ int i;
  parameters.snormal++;
  parameters.snormal = parameters.snormal % 3;
  *xx = -5;
}
extern char encode[][20];
get_encode(int *xx)
{
parameters.sencode++;
parameters.sencode = parameters.sencode % 4;
*xx = -5;
}
extern char prepro[][20];
get_prepro(int *xx)
{
parameters.sprepro++;
parameters.sprepro = parameters.sprepro % 4;
*xx = -5;
}


free_data()
{
free_double(data,(parameters.examplars+parameters.exam_test));
free(class);

}

load_data(char *ffname){
int i,j,x,targeti;
FILE *dfp;

if(!strcmp(ffname,"edit")){edit_a_datafile();return;}

dfp=fopen(ffname,"r");

load_header(dfp);

 data = DMALLOC_FILL(examplars+exam_test,parameters.input);
 class = MALLOCI_FILL(examplars+exam_test,"Class");
 if(parameters.sencode == VECTOR)
   data_out =DMALLOC_FILL((examplars+exam_test),parameters.output);

  loopi(examplars+exam_test){
      fscanf(dfp,"%d",&x);
      loopj(parameters.input){ fscanf(dfp,"%g ",&data[i][j]);}
	 switch(parameters.sencode){
	      case CLASS:
	      case BINARY:
		 fscanf(dfp,"%d",&targeti);class[i] = targeti;break;
	      case VECTOR:loopj(parameters.output)
		 { fscanf(dfp,"%g ",&data_out[i][j]);}
		   class[i] = -1;break; }}
	 fclose(dfp);
}

load_header(FILE *dfp)
{
fscanf(dfp,"%d %d %d %d",&parameters.examplars,
			 &parameters.exam_test,
			 &parameters.input,
			 &parameters.output);

true_output = parameters.output;
if(parameters.sencode == 1) {true_output = parameters.output;
     parameters.output = (int)(0.9+log((double)parameters.output)/log(2.0));}
 examplars = parameters.examplars;
 exam_test = parameters.exam_test;

}
int sample,ctype;
/*

Make input grabs an input vector from the the list and stuffs
it in x.  The randomization is based on two things, first randomized on
examplar number then randomized on class.

Negative values ensure random data. Positive values select a specific
exemplar.

*/
extern long count;

MAKE_INPUT(float *x,float *doft,int randx)
{ int i,breaker,aswitch;

get_sample(randx);

loopi(parameters.input) {   x[i] = data[sample][i]+
				 randomy()*parameters.add_noise;}
switch(parameters.sencode)
	      {case CLASS:loopi(parameters.output)
		     { if(i==ctype) doft[i] = 1.0;else doft[i] = 0.0;}break;

	       case BINARY:loopi(parameters.output) { if((binx[i]&ctype)>0)
		      doft[parameters.output-1-i]= 1.0;
		      else doft[parameters.output-1-i]=0.0;}break;
		case VECTOR:loopi(parameters.output)
			doft[i]=data_out[sample][i];break;    }

}

get_sample(int xx)
{    int breaker = 0;
if(parameters.sencode == VECTOR){ sample = random_int(examplars);
				  ctype = -1;return;}

if(xx < 0){ /*Normal */
		ctype = random_int(parameters.output) ;
		sample = random_int(examplars);
      if(true_output < 6){
	    while(class[sample] != ctype)
               {sample= random_int(examplars);
		if(breaker++ > 500){
		printf("\nCan't Find %d",ctype);write_data();exit(0);}}}
      else ctype = class[sample];

		      }

	     else{  sample = xx;
			ctype = class[sample];}



}



float randomy()
{ int x;
  float rnx;
  x = rand() % 1000;
 rnx = (float)x/1000. -0.5;
 return rnx;}


open_stats(){ fst = fopen("data_stats","w");}
close_stats() { fclose(fst); }

random_int(range)
int range;
{int xt=0;
 xt = (int)lrand48();
 xt = xt & 1023;
 xt = xt % range;
return xt;
}
open_data_file(filename)
char *filename;
{ FILE *fp;

	if(!strcmp(filename,"edit")){return TRUE;}

	fp=fopen(filename,"r");

	 if(fp==NULL){
		gotoxy(4,9);printf("File not Found");sleep(1);
	       gotoxy(4,9);printf("              ");
	       strcpy(filename,"");
	       return FALSE;
	       }
fclose(fp);
return TRUE;
}
#define checkESC2 if(first==ESC){return ESC;}
get_file_name(aname)
char *aname;
{ int first;
       reset_directories();
       chdir(dirname);
       do_direc(parameters.dirmask);
       settextstyle(SMALL_FONT,0,4);
       outtextxy(12,10,"Data Directory:");
       outtextxy(12,40,"Data File:");
       get_string(10,25,0,15,dirname,"data",BLACK,YELLOW);
       chdir(dirname);
       do_direc(parameters.dirmask);
       get_string(10,55,0,15,aname,aname,BLACK,YELLOW);

return ESC;
}




places eitem[6]= {{"Input Features",40,75,"2",8},
		  {"Output Classes",320,75,"2",8},
		  {"Exemplars ",40,95,"4",8},
		  {"Test Exemplars",320,95,"0",8},
		  {"File Name",40,120,"noname.dat",12},
                  {"Noise",320,120,"0.0",8}};

edit_a_datafile()
{ int i;
exit_menu();
clearviewport();
setcolor(RED);
setcolor(CYAN);
make_cover();
shadowtext(420,25,2,"Data Set Editor");
build_data_box();
build_header();

data  = DMALLOC_FILL(examplars+exam_test,parameters.input);
class = MALLOCI_FILL(examplars+exam_test,"class");


show_data();
edit_data();

}
build_header()
{ int i;
  char avalue[80];

loopi(6) {shadowtext(eitem[i].x,eitem[i].y,2,eitem[i].name);
	 setcolor(YELLOW);settextstyle(TRIPLEX_FONT,0,2);
	 outtextxy(eitem[i].x+160+8*textwidth(" ")-
				textwidth(eitem[i].init),
				 eitem[i].y,eitem[i].init);}

settextstyle(TRIPLEX_FONT,0,2);
loopi(6) {get_string(eitem[i].x,eitem[i].y,160+(8-eitem[i].field)*textwidth(" "),
           eitem[i].field,avalue,eitem[i].init,DARKGRAY,YELLOW);
	  switch(i){
	     case 0:sscanf(avalue,"%d",&parameters.input);break;
	     case 1:sscanf(avalue,"%d",&parameters.output);break;
	     case 2:sscanf(avalue,"%d",&examplars);break;
	     case 3:sscanf(avalue,"%d",&exam_test);break;
	     case 4:sscanf(avalue,"%s",parameters.file);break;
             case 5:sscanf(avalue,"%f",parameters.add_noise);break;}
	     }


}
int font_size;
build_data_box()
{

shadowbox(25,150,615,330);
setcolor(CYAN);
settextstyle(SMALL_FONT,0,font_size);
outtextxy(100,150,"Features ");
outtextxy(550,150,"Class");
settextstyle(SMALL_FONT,1,5);
outtextxy(30,200,"Examplar");
}
extern int wide2,high2;
show_data()
{
int i,j,x1,y1;
char value[80];
font_size = 4;
settextstyle(SMALL_FONT,0,font_size);
setfillstyle(SOLID_FILL,LIGHTGRAY);
setcolor(BLUE);
wide2 = textwidth(" ")*8;
high2 = textheight(" ");
loopj(examplars+exam_test){
	y1 = yi(j);
	loopi(parameters.input){
	x1 = xi(i);
	barit;
	   sprintf(value,"% 5.3f",data[j][i]);
	   bartext(value);

} }
wide2 = textwidth(" ")*3;
loopj(examplars+exam_test){
	  y1 = yi(j);
	  x1 = 70;
	   barit;
	   sprintf(value,"%2d",j);
	   bartext(value);
	   x1 = 560;
	   barit;
	   sprintf(value,"%2d",class[j]);
	   bartext(value);

			   }


}
edit_data()
{ int i,j,all,other;
  char value[8];
  float fvalue;
  setcolor(BLUE);
  settextstyle(SMALL_FONT,0,font_size);
  i = 0;j = 0;
  all = examplars + exam_test;
  other =  parameters.input +1;
/*This sequence marches through the table.
  Type number to enter, controls to move around. */

while(TRUE){int xx;
   if(j != parameters.input){
   wide2 = textwidth(" ")*8;
   sprintf(value,"% 6.3f",data[i][j]);
   xx = get_string(xi(j),yi(i),0,8,value,value,LIGHTGRAY,BLUE);
   if(xx == 0) sscanf(value,"%f",&data[i][j]);}
else {
   wide2 = textwidth(" ")*3;
   sprintf(value,"%3d",class[j]);
   xx = get_string(560,yi(i),0,3,value,value,LIGHTGRAY,BLUE);
   if(xx == 0) sscanf(value,"%d",&class[j]);
}
   if(kbhit()) xx = getch();
   if(xx == ESC) break;
   if(xx == RIGHT) j =  (j+1) % other;
   if(xx == LEFT)  j =  (j-1+other)%other;
   if(xx == DOWN)  i =  (i+1) % all;
   if(xx == UP)    i =  (i-1+all) % all;

  }
save_data(parameters.file);
printf("saved as: %s ",parameters.file);
}
xi(i) int i;{return (100+(i*(wide2+8))); }
yi(j) int j;{return (170+(j*(high2+6)));}

save_data(afilename)
char *afilename;
{FILE *fp;
 int i,j;
 fp = fopen(afilename,"w");
 if(fp == NULL) return;
 fprintf(fp,"%d %d %d %d \n",examplars,exam_test,parameters.input,
			    parameters.output);

loopi(examplars+exam_test){
       fprintf(fp, "%d   ",i);
       loopj(parameters.input) fprintf(fp,"% 6.3f  ",data[i][j]);
		   fprintf(fp,"  %d \n",class[i]);}


fclose(fp);


}
write_data()
{int i,j;
printf("\n");
printf("looking for Class %d \n",ctype);
loopi(parameters.examplars+parameters.exam_test)
{ printf("%3d ",i);
  loopj(parameters.input) printf("% 3.2f ",data[i][j]);
  printf("%3d \n",class[i]);
}


}
do_preproc()
{ int i,j,k,newsize,pntr; float **datax,**dtemp;
switch(parameters.sprepro){
case 0:break;
case 1: datax = DMALLOC_FILL(examplars+exam_test,parameters.input*2);
       loopi(examplars+exam_test){
	  loopj(parameters.input){
	    datax[i][j*2] = data[i][j];
	    datax[i][j*2+1] = data[i][j]*data[i][j];}}
	free_double(data,(parameters.examplars+parameters.exam_test));
	data=datax;
	parameters.input = parameters.input*2;break;

case 2: newsize =((parameters.input)*(parameters.input+1))/2+parameters.input;
    datax = DMALLOC_FILL(examplars+exam_test,newsize);
    dtemp = DMALLOC_FILL(parameters.input,parameters.input);
       loopi(examplars+exam_test){
	  loopj(parameters.input){
	    loopk(parameters.input){
		 dtemp[j][k] = data[i][j]*data[i][k];}}
	   loopj(parameters.input) datax[i][j] = data[i][j];
	   pntr = parameters.input;
	   loopj(parameters.input){
	     loopk(j+1){datax[i][pntr++] = dtemp[j][k];}
				  }
	    }
	free_double(data,(parameters.examplars+parameters.exam_test));
	free_double(dtemp,parameters.input);
	data=datax;
	parameters.input = newsize;break;
}

}
data_error()
{
setcolor(WHITE);
clearviewport();
setfillstyle(SOLID_FILL,BLUE);
bar(0,0,640,350);
shadowtext(20,40,3,"Data File Error Screen");
settextstyle(2,0,5);
settextstyle(2,0,4);
setcolor(BLACK);
outtextxy(20,240,"Your Data File Should Look Like This");
outtextxy(20,250,"5 5 3 2 ");
outtextxy(20,260,"1 6.0   150.   1");
outtextxy(20,270,"2 5.0   220.   2");
outtextxy(20,280,"3 6.2   180.   1");
outtextxy(20,290,"4 5.3   145.   2");
outtextxy(20,300,"5 6.0   150.   1");
outtextxy(20,310,"6 5.2   239.   2");

 outtextxy(20,320,"Your Data File Should Look Like This");

getch();
}