/************************************************************
*							     *
*  Program: Neural Net Simulator			     *
*							     *
*  Author: Greg Tarr                  Date:19 May 1990       *
*							     *
*  Module:Menu Items 					     *
*  SubModules: Menustr.h (storage for menu data structs.     *
*  Super Module: title.c                                     *
**************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <graphics.h>
#include <defines.h>
#include <menustr.h>
#include <ascii.h>

extern setup parameters;

extern int display,right,called;

extern char the_name[],get_string();
extern nnet *net;
void menup();
float neta=1.0,momentum=0.7;

int do_train_it= TRUE;
#define ax 10
void *buffer;

menu()
{  char select,filename[20];
switch(getch()){
case 't': do_Single(); break;
case 'p': menu_windowx(450,30);menup();exit_menu();break;
case ESC:
case 'q': exitp();break;
case 's': menu_windowx(100,0);
          outtextxy(ax,10,"Enter Filename: ? ");
	  get_string(ax,30,0,10,filename,"junk.wei",BLACK,YELLOW);
		    write_weights (filename);
                    exit_menu();
	            break;

case 'r': menu_windowx(200,0);
          outtextxy(ax,10,"Enter Filename: ? ");
	  get_string(ax,30,0,10,filename,"junk.wei",BLACK,YELLOW);
	  read_weights (filename);
          exit_menu();
          percp_scn();
	  DISPLAY_SCREEN();
          break;
case 'h': do_help("help1.doc");restore_after();break;
case 'l': do_train(TRUE);break;
case 'x': do_screen_dump();break;
case 'e': examine_net();break;
case 'f': do_FAST();break;
defaults: exit_menu();break;
}
}
examine_net(){clearviewport();}
extern do_fast;
do_FAST()
{ do_fast = do_fast ^ 1;}

do_train(displayx)
int displayx;

{
            if(displayx==TRUE) do_train_it =do_train_it ^ TRUE;
            if(do_train_it==TRUE)
		 aboxer(180,2,"Learning  ON ",0,CYAN,YELLOW);
         	   else
		 aboxer(180,2,"Learning  OFF",YELLOW,CYAN,BLUE);

}

init_head()
{        char junk;
	 char junk2[20];
	 strcpy(junk2,"");
	 settextstyle(SMALL_FONT,0,4);
	 setcolor(CYAN);
		    outtextxy(ax+20,5,"Net Topology");
		    outtextxy(ax,25,"Number of Layers ? ");
		    outtextxy(ax+20,45,"Hidden Nodes");
	    get_string(ax,25,100,3,junk2,"2",BLACK,YELLOW);
	    fflush(stdin);
	    sscanf(junk2,"%d",&parameters.layers);

	     {int i;loopi(parameters.layers-1){
	     get_string(100-i*40,60,0,3,junk2,"5",BLACK,YELLOW);
	     sscanf(junk2,"%d",&parameters.hide[i]);
		       }      }

		}

#define window_high  170
#define window_wide  150

menu_windowx(xl,yl)
int xl,yl;
{
   getimage(xl,yl,xl+window_high,yl+window_wide,buffer);
      setviewport(xl,yl,xl+window_high,yl+window_wide,1);
   clear_window();
 }

init_window()
{
   long image_size;
   image_size = imagesize(0,0,window_high,window_wide);
   buffer = (void *)malloc(image_size);
   if(buffer == NULL) {printf("No Memory for graphics ");exit(0);}
}
free_buffer(){free(buffer);}
clear_window()

{  setcolor(CYAN);
   setlinestyle(0,0,1);
   shadowbox(1,1,window_high-10,window_wide-10);
   setcolor(CYAN);
}

exit_menu()
{
    putimage(0,0,buffer,COPY_PUT);
    setviewport(0,0,639,349,1);
    }
char write_menu(thestring,thecodes)
amenu_type thestring[];
int thecodes[];
{  int i,choice;
   char junk[20];
   setcolor(RED);
   settextstyle(2,0,5);
   loopi(thecodes[0]){menu_color(thecodes[i+1]);
                      outtextxy(ax,10+10*i,thestring[i]);
            if(i>0){setcolor(CYAN);
	         sprintf(junk,"%c%c",thestring[i][0],0);
	         outtextxy(ax,10+10*i,junk);}}
                 gotoxy(25,9);return getch();
}
menu_color(x)
int x;
{  switch (x){
   case TRUE: setcolor(YELLOW);
	      settextstyle(2,0,4);
	      break;
    case FALSE: setcolor(LIGHTGRAY);
	        settextstyle(2,0,3);
		break;
    case 3: setcolor(WHITE);
	    settextstyle(2,0,5);
	    break;
	     }

   gotoxy(25,9);
}
#define add(A,B,C) sprintf(junk,C,A);strcat(para_adjust_str[B],junk);


places pmenu[8]= {{"Learning Rate ",0,0,"0.3",8},
		  {"Momentum      ",0,0,"0.7",8},
		  {"Display Every ",0,0,"200",8},
		  {"Noise         ",0,0,"0.0",8},
		  {"Data Normalize",0,0,"None",8},
		  {"Output Encode ",0,0,"None",8},
		  {"Preprocess    ",0,0,"None",8}};

extern int wide2,high2;

extern char normal[][20],encode[][20],prepro[][20];
#define SKIP -5
void menup()
{ char junk[20];
int i,k,x1,y1,xx;
draw_pmenu();

    k=0;

while(TRUE) {draw_pmenu();
	     xx = get_string(20,k*12+30,70+(10-pmenu[k].field)*textwidth(" "),
	     pmenu[k].field,pmenu[k].init,pmenu[k].init,BLACK,YELLOW);
	     if(kbhit()) xx = getch();
	     if(xx == ESC) break;
  switch(k){
       case 0: sscanf(pmenu[k].init,"%f",&neta);
	       loopi(parameters.layers)
		 net->layer1[i]->eta[0] = neta;break;
       case 1: sscanf(pmenu[k].init,"%f",&momentum);
	       loopi(parameters.layers)
		 net->layer1[i]->eta[1] = momentum;break;
       case 2: sscanf(pmenu[k].init,"%d",&display);break;
       case 3: sscanf(pmenu[k].init,"%f",&parameters.add_noise);break;
       case 4: if(xx == RIGHT) get_normal(&xx);
       case 5: if(xx == RIGHT) get_encode(&xx);
       case 6: if(xx == RIGHT) get_prepro(&xx);

       }
       INC(&k,8,xx);
	    }
}
draw_pmenu()
{ int i,x1,y1;
setcolor(BLUE);
sprintf(pmenu[0].init,"%5.2f",neta);
sprintf(pmenu[1].init,"%5.2f",momentum);
sprintf(pmenu[2].init,"%3d",display);
sprintf(pmenu[3].init,"%5.2f",parameters.add_noise);
sprintf(pmenu[4].init,"%s",normal[parameters.snormal]);
sprintf(pmenu[5].init,"%s",encode[parameters.sencode]);
sprintf(pmenu[6].init,"%s",prepro[parameters.sprepro]);

setcolor(YELLOW);
outtextxy(10,5,"   ===Parameters===");

       wide2 = 8 * textwidth(" ");
       high2 = textheight(" ");

loopi(8) { x1=10;y1=i*12+30;
    outtextxy(x1,y1,pmenu[i].name);x1 = 102;
    barit;
    bartext(pmenu[i].init);}

}
do_Single()
{ int i,xx;
  char astring[80];
  settextstyle(SMALL_FONT,0,4);
  outtextxy(20,50,"Press ESC when done");
  i = 0;
while(TRUE){
	xx = get_string(node_at_x(i,parameters.input)-1,node_at_y(0)-13,
		     0,7,astring,"",BLUE,YELLOW);
	if(kbhit()) xx = getch();
	if(xx == ESC) break;
	sscanf(astring,"%f",&net->inp[i]);
	INC(&i,parameters.input,xx);
	DISPLAY_SCREEN();}
	   FEED_FORWARD();
	   DISPLAY_SCREEN();

	   sprintf(astring,"The input classified as : %d",called);
	   outtextxy(50,80,astring);

	   getch();
}
INC(x,lim,which)
int *x,lim,which;
{ int xx; if(*x == SKIP) return;
  xx = *x+lim ;
  if((which == DOWN)|(which==RIGHT)|
     (which == RETURN)|
     (which == 0)) xx++;
  if((which == UP)|(which == LEFT)) xx = xx-1;
  xx = xx % lim;
  *x = xx;
}
char gmenu(helpfile,restore_screen)
char *helpfile;
int (* restore_screen)();
{   if(!kbhit()) return 0;
       switch(getch()){
		case 'q':fflush(stdin);return 'q';
		case 'p':getch();fflush(stdin);return 0;
		case 'h':do_help(helpfile);
			 restore_screen();return 0;
		case 'r':fflush(stdin);return 'r';
		case 'x':do_screen_dump(); return 0;
		}
fflush(stdin);
	}
extern int reset;

void system_switches()
{reset = TRUE;
  setcolor(RED);
  rectangle(400,20,580,150);
  menup_viewport(401,21,579,149,1);
  clearviewport();
  menup();}
menup_viewport()
{  setviewport(401,21,579,149,1);}