/*************************************************************
*							     *
*  Program: Neural Net Simulator			     *
*							     *
*  Author: Greg Tarr                  Date:19 May 1990       *
*							     *
*  Module:adds paradigms to the paradigm menu.  	     *
*  SubModules:                                               *
*  Super Module: title.c                                     *
**************************************************************/
#define NULL 0
#include <stdio.h>
#include <stdlib.h>

#include <graphics.h>
#include <defines.h>

ITEMS items[30];

int number_choices = 0;
extern int reset;

void add_a_function(char *newstuff,void (* infunction)());
void display_choices(ITEMS *,int,int,int,int);

/* function pointers for paradigm initializers */

void (* initialize_paradigm[20])();
char do_help();
extern void init_train_BACKPROP(void),init_train_BACKPROP2(void);
extern void init_train_BACKPROP5(void),init_train_CONIC(void);
extern void init_train_HYBRID(void),init_train_RADIAL(void);
extern void init_train_KOHONEN(void),init_train_BRAIN(void);
extern void init_train_Kohon(void),system_switches(void);
extern void data_error(void);
extern void kohonen(void),hopfield(void),HELP(void),
	     tutorial(void),license(void),bam(void);

void sales(void){reset = TRUE;do_sales();}

void quitit(){exit(0);}

extern setup parameters;
int quit_choice;

void init_choices(void)
{
  parameters.READY = 0;
  number_choices = 0;

  add_a_function(" Preset Parameters  ",system_switches);
  add_a_function(" Back Propagation   ",init_train_BACKPROP);
  add_a_function(" Back Prop w/ momen ",init_train_BACKPROP2);
  add_a_function(" Conjugate Gradient ",init_train_BRAIN);
  add_a_function(" Hybrid  Network    ",init_train_HYBRID);
  add_a_function(" Radial Basis       ",init_train_RADIAL);
  add_a_function(" Function Approx    ",init_train_BACKPROP5);
  add_a_function(" Kohonen Demo       ",kohonen);
  add_a_function(" Kohonen Classifier ",init_train_Kohon);
  add_a_function(" Traveling Salesman ",sales);
  add_a_function(" Hopfield Ass Memory",hopfield);
  add_a_function(" BAM Ass Memory     ",bam);
  add_a_function(" Help               ",HELP);
  add_a_function(" Tutorial           ",tutorial);
  add_a_function(" License Agreement  ",license);
  add_a_function(" Exit               ",quitit);
quit_choice = number_choices -1;
reset = TRUE;
items[get_choice()].place();

}

void add_a_function(char *newstuff,void (* infunction)())
/*char newstuff[];
void (* infunction)(); */
{  strcpy(items[number_choices].name,newstuff);
   items[number_choices].place = infunction;
   number_choices++;

}

/*  this function is a dummy used when the weights are fixed */

void TRAIN_NULL(){}
extern char the_name[];

int the_choice = 0;

int get_choice()
{ int row,rowx,rowy,i,choice,paint,getarrow=0;
char junk[80];
setcolor(WHITE);
fflush(stdin);

while(TRUE){  display_choices(items,30,220,number_choices,the_choice);
	      getarrow = getch();
	      the_choice = do_arrow(getarrow,number_choices,the_choice);
	      if(getarrow == 13) break;
	      if((getarrow == 27)|(getarrow == 'q')) return (quit_choice);
	    }

strcpy(the_name,items[the_choice].name);
parameters.train_rule = the_choice;
return the_choice;
}

int do_arrow(getarrow,number_choices,the_choice)
int getarrow,number_choices,the_choice;
{
if (getarrow == 0) getarrow = getch();

		      switch(getarrow){

			  case 80:if(the_choice < number_choices-1)
				       the_choice++;break;
			  case 72:if(the_choice > 0)
				       the_choice=the_choice -1;break;
			  case 77:if((the_choice + 5) < number_choices)
				       the_choice += 5;break;
			  case 75:if((the_choice - 4) > 0)
				      the_choice = the_choice-5;}

return the_choice;

}
void display_choices(aitem,x,y,number_choices,the_choice)
ITEMS aitem[];
int x,y,number_choices,the_choice;
{ int i,row,rowx,rowy,paint;
loopi(number_choices){row = i/5;
		      rowx = row * 150+x;
		      rowy = y-75*row;
		      paint = (i==the_choice) ? CYAN : BLACK ;
		      setfillstyle(SOLID_FILL,paint);
		      bar(rowx,15*i+rowy,120+rowx,10+15*i+rowy);
		      outtextxy(rowx,rowy+15*i,aitem[i].name);}
}