/*************************************************************
*							     *
*  Program: Neural Net Simulator			     *
*							     *
*  Author: Greg Tarr                  Date:19 May 1990       *
*  NAME: Module for hybrid
*  MODULE NUMBER: 1.6
*  DESCRIPTION: Using output, adjusts wights reduce error.
*  ALGORITHM: Werbos Multilayer Perceptron Backpropagation.
*							     *
*  Module: 						     *
*  SubModules:                                               *
*  Super Module: title.c                                     *
**************************************************************/

#include <defines.h>
#include <math.h>
#include <stdio.h>

extern nnet *net;

extern setup parameters;

extern float calcy();
float calcr();
extern float hardness;
extern void TRAIN_LOWER_LAYER2(),
	     TRAIN_OUTPUT_LAYER2();
	     TRAIN_NULL();
void TRAIN_RADIAL_LAYER();
extern int reset;
float **spread;
float **DMALLOC_FILL();

init_train_RADIAL()
{int i;
  strcpy(parameters.dirmask,"*.dat");
  reset = FALSE;
  if(!parameters.READY) return;
  init_net(parameters);
  loopi(parameters.layers){
                net->layer1[i]->updater = TRAIN_LOWER_LAYER2;
		net->layer1[i]->eta[0] = 0.2 ;
		net->layer1[i]->eta[1] = 0.7 ;
                                        }
	net->layer1[parameters.layers-1]->updater = TRAIN_OUTPUT_LAYER2;
	loopi(parameters.layers)
                net->layer1[i]->propagate = calcy;
	net->layer1[0]->updater = TRAIN_RADIAL_LAYER;
	net->layer1[0]->propagate = calcr;
	spread = DMALLOC_FILL(parameters.hide[0],parameters.input);

}

init_train_RADIAL2()
{int i;
  reset = FALSE;
  if(!parameters.READY) return;
  init_net(parameters);
  loopi(parameters.layers){
                net->layer1[i]->updater = TRAIN_LOWER_LAYER2;
		net->layer1[i]->eta[0] = 0.2 ;
		net->layer1[i]->eta[1] = 0.7 ;
                                        }
	net->layer1[parameters.layers-1]->updater = TRAIN_OUTPUT_LAYER2;
	loopi(parameters.layers)
                net->layer1[i]->propagate = calcy;
	net->layer1[0]->updater = TRAIN_RADIAL_LAYER;
	net->layer1[0]->propagate = calcr;
	spread = DMALLOC_FILL(parameters.hide[0],parameters.input);

}

void TRAIN_RADIAL_LAYER(l_on,l_up)
layer *l_on,*l_up;

{ int i,j,k,lower,upper;
  float neta,momentum;
  lower = l_on->size_input;
  upper = l_on->size_output;

  neta = l_on->eta[0]*(float)lower;
  momentum = l_on->eta[1]=0.2;
  delx(l_on->output,l_up->delta,l_on->delta,
	      l_up->weights,l_up->size_output,upper);

  loopj(upper) {
    loopi(l_on->size_input) {
       l_on->momentum[j][i] = -(neta *  l_on->delta[j] *
				  (l_on->input[i] - l_on->weights[j][i])
				  + momentum * l_on->momentum[j][i]);
      l_on->weights[j][i] += l_on->momentum[j][i];
      spread[j][i] += (neta* 0.1 *  l_on->delta[j] * spread[j][i]);

               }}
}
float fixr();

float calcr(layer *l_on,int number)
 {int i,k;
   float y,xx;

   y = 0.0;

   loopi(l_on->size_input){float sd;
	       sd = spread[number][i]*spread[number][i];
	       xx = (l_on->input[i]-l_on->weights[number][i])/sd;
 		y = y + xx*xx;}
   return fixr(y,5.0);}

float fixr(y,hard)
float y,hard;
{return hard*exp(-y);}