/*************************************************************
*							     *
*  Program: Neural Net Simulator			     *
*							     *
*  Author: Greg Tarr                  Date:19 May 1990       *
*							     *
*  Module: test.c :  test the output of the net and measures *
*                    the performance.			     *
*  SubModules:                                               *
*  Super Module: title.c                                     *
**************************************************************/

#include <stdio.h>
#include <math.h>
#include <defines.h>

extern int display,graphics;

extern int right,good,test,exam_test,examplars,sample,ctype;
extern nnet *net;
extern setup parameters;
extern int classmask[];

int decisions,TEST,cguess;
float accuracy;

#define TRUE 1
#define FALSE 0
float error[20],err=0.0,class_err;
float the_test = 0.25;
float history[HIS_SIZE];
int indx=0;
int mistakes = 0;
int indexx = 0,called;
CHECK_ERRORS(y,doft)
   float y[];
   float doft[];
   { int i=0,j;
     int correct_right=0;
     class_err = 0.0;
	 loopi(parameters.output) { error[i] = (float)doft[i]- y[i];
	             if (error[i] < 0.)   error[i] = -error[i];
                     if (error[i] < the_test) correct_right++;
		     class_err += error[i]*error[i];
		     }
	 err=class_err;
	 class_err = (float)sqrt((double)class_err);
called = maxfinder(y);
if( called == ctype)good++;

if (correct_right == (parameters.output))right++;
   }


int binxx[8] = {1,2,4,8,16,32,64,128};

maxfinder(invec)
float invec[];
{int maxi,i,lwide,ivalue=0;
 float max=0.0;
if(parameters.sencode == 1){
 loopi(parameters.output){ if(invec[i] > 0.5) ivalue +=
		    binxx[parameters.output-1-i]; }
 return ivalue;}
 else
   { loopi(parameters.output){if(max < invec[i]){max = invec[i];
			      maxi = i;}}
             }

return maxi;
}

CHECK(y,doft)
   float y[];
   float doft[];
   { float missed_by=0;
    int i,j;
    loopi(parameters.output)  { missed_by = (float)doft[i]- y[i];
                     err += missed_by * missed_by; }
                     cguess = maxfinder(y);
missed_by = 0.;         }

clear_test()
{    int i;
     right = 0;good = 0;decisions = 0;
     err=0.0;; }

DO_TEST()
{  int i,j,rights,goods,test_number,toffset;

     calculate_error();

     if(exam_test == 0){test_number = examplars;
			toffset = 0;}
     else {test_number = exam_test;
	   toffset = examplars;}

     rights=right;goods=good;
     clear_test();
     loopi(test_number){
	  MAKE_INPUT(net->inp, net->doft,i+toffset);
	  FEED_FORWARD();
	  CHECK_ERRORS(net->outp,net->doft) ;
	  display_report(i);
   }
       err = (float)sqrt((double)err);
       write_stats(350,326,right,good,"Test",test_number);

       TEST = FALSE;

     right=rights;good=goods;
random_fill();

}
random_fill()
{
	  MAKE_INPUT(net->inp, net->doft,-1);
	  FEED_FORWARD();

}


calculate_error()
{   int i,j,smooth;
    FILE *fex;
    clear_test();
    if(parameters.add_noise > 0.0 ) smooth = 10;
    else smooth = 1;
loopj(smooth){
loopi(examplars){
      MAKE_INPUT(net->inp,net->doft,i);
      FEED_FORWARD();
      CHECK_ERRORS(net->outp,net->doft);
}
}
       err = (float)sqrt((double)err);
       write_stats(20,326,right,good,"Train",(examplars*smooth));
       put_history();


}
put_history()
{ int i;
 history[indx]=err;
 show_error(history,indx);
 indx++;indx = indx % HIS_SIZE;


}
CHECK2(y,doft)
   float y[];
   float doft[];
   { float missed_by=0;
    int i,j;
    loopi(parameters.output)  {
                      missed_by = (float)doft[i]- y[i];
                       err += missed_by * missed_by;
   }

missed_by = 0.;         }
