/*************************************************************
*							     *
*  Program: Neural Net Simulator			     *
*							     *
*  Author: Greg Tarr		  Date:19 May 1990           *
*							     *
*  Module: title.c : Main Program Module		     *
*  SubModules:                                               *
*  Super Module: title.c                                     *
**************************************************************/
/*
   This module is the main setup and options
  menu. All other module are called from here

*/

#include <graphics.h>
#include <stdio.h>
#include <stdlib.h>
#include <defines.h>
#include <dir.h>

extern ITEMS *items;
char curwdir[80] ;
/* defines.h includes commom macros found through out the program
   for example loopi(A) means for(i=0;i<A;i++).
   Since loops occur so often in neural nets, this macro make
   the code more readible.                                            */
void reset_directories();

extern  setup parameters;
int reset = FALSE;
 /*****************
 */    main()   /*
/******************/
{ char select;

  getcwd(curwdir,80);
  srand((unsigned int)time());
  make_screen();           /* Hardware Initialization */

  restart:
     reset_directories();
     make_screenx();      /* Graphics Screen  */

     init_choices();

     if(reset == TRUE) goto restart; /* If the program is a demo
				       or setup, the setup is performed
				       and the program goes back to
				       the top.  */

    percp();
    parameters.sencode = CLASS;
  /* percp is the program which run most feedforward
     models.  The choice here is to go into a model
     and stay there like most of the demos, or simply
     initialize the feedforward models the return, and
     run percp(). */

  goto restart;
}
#if FALSE

Source Code for the Neural Graphics Neural Network Simulator
The souce code is composed into the following modules.

title.c         Opening menu and title screen.
percp.c         main program for feedforward models.
graphics.lib    graphics library (not included).
fonts.lib       A library of font (not included).
makeinp.c       Module to get data from data files to the network.
initit.c        Initialization routines, memory management.
menu.c          Interactive menus for user control.
saver.c         Save and Read Weight files.
dump.c          Dump a pixel map of the screen to a file.
feed.c          Performs the propagate function using function pointers.
backprop.c      Performs the trainning function using function pointers.
test.c          Tests the output based on the output and desired values.
display.c       Display functions.
help.c          Context Sensitive help menues.
show.c          Used for ascii output for debugging paradigms.
paradigm.c      Allows adding paradigms easily.
bp.c            Paradigm: Back propagation without momentum.
bp2.c           Paradigm: Back propagation with momentum.
koh2.c          Paradigm: Kohonen Classifier.
hybrid.c        Paradigm: Hybrid networks.
radial.c        Paradigm: Radial Basis Functions.
adept.c         Adaptive filter demonstration.
amenu.c         adaptive filter menus.
kohonen.c       kohonen map demonstration.
hopfield.c      hopfield associative memory program.
hmenu.c         hopfield menu submodule.
hmakein.c       hopfield version of the makeinput package.
help.doc        An Ascii file for using in the online help utility.
		(not included).
#endif

void reset_directories(){
chdir(curwdir);}

