/*************************************************************
*							     *
*  Program: Traveling Saleman Problem			     *
*							     *
*  Author: Greg Tarr                  Date:19 May 1990       *
*							     *
*  Module: Main						     *
*  SubModules: Graphics and Font Libraries                   *
*  Super Module:                                             *
**************************************************************/

#include <graphics.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <ascii.h>
#include <alloc.h>

#include <defines.h>
extern setup parameters;
/*
#define loopi(A) for(i=0;i<(A);i++)
#define loopj(A) for(j=0;j<(A);j++)*/

#define MAXNODES 300
#define line printf("\n")
#define beep printf("\a");
#define empty 0
#define used 1
#define full 1
#define got 1

#define squarex(A) ((A)*(A))

#define TRUE 1
#define FALSE 0

char junksx[80];
int sales_screen();
float neigh,dist;
int neighborhoods;
#define gotoxy(A,B) moveto((A)*9,(B)*8);setcolor(BLUE)
float random();
float distance();
FILE *open_data_file();
float gain2 = 0.5,gainx;
int dump = 2;

typedef struct { float x,y;
		int cap,count,close;} nnode;

typedef struct { float x,y,inhibit;
	       int cap;} ccity;

ccity *city;
nnode *node;

extern int reset;
int node_top,city_top = 10,min_node,junk,caught=1;
float min_dist,min_x,min_y;

float *ring;
char dowhat=1;
do_sales()

{ int i=0,j,k,the_city,do_what;
while(TRUE){
  i=0;do_what=0;
  S_INITIALIZE();
     while(do_what == 0){  i++;
			   do_sales_step(i);
			   do_what = gmenu("sales\\sales.doc",sales_screen);}
    free_sales();
    if(do_what == 'r') continue;
    if(do_what == 'q') break;
	     }
reset = TRUE;
}
do_sales_step(i)

int i;
{ int j;
	display_cities();
	loopj(city_top){
		find_min(j);
		train_net(j);}

	do_numbers(i,j);
	clear_count();
	compute_ring();

}

free_sales()
{
free(city);
free(node);
free(ring);
}


train_net(j)
int j;
{ int i,tindex,extra;
  float gain3;

    if(city[j].inhibit == TRUE) return;
    neigh = neigh * (1.0 - gainx);
    neighborhoods = (int)((float)node_top * neigh)+1;

    loopi(neighborhoods){
       tindex = index_node(i);

       gain3 = gain2*dist;
       node[tindex].x =(1.0-gain3) * node[tindex].x+
	    gain3 * city[j].x ;
       node[tindex].y =(1.0-gain3) * node[tindex].y+
	    gain3 * city[j].y;
    }
    write_view();

    sprintf(junksx,"Nearest Node  %3d ",min_node);
    write_string(30,120,junksx);
    sprintf(junksx,"Neighboorhood %3d ",neighborhoods);
    write_string(30,140,junksx);
    unwrite_view();
}



extern char *filename,*dirname;
do_numbers(i,j)
int i,j;
{
write_view();
sprintf(junksx,"City %2d Nodes: %2d ",j,node_top);write_string(30,160,junksx);
sprintf(junksx,"Survey: %d ",i);write_string(350,30,junksx);
sprintf(junksx,"Gain: %3.2f ",gain2);write_string(350,45,junksx);
sprintf(junksx,"Neighbohood decline %3.4f ",gainx);write_string(350,60,junksx);
unwrite_view();
}

S_INITIALIZE()
{ int hold,i,getrandom;

  float x,y,decline=0.08;
  char type[80];
  char aname[80];
  FILE *fpx;
  make_screen();
  sales_screen();
  strcpy(parameters.dirmask,"*.sal");
  setviewport(1,120,300,300,1);
  shadowbox(5,5,200,100);
  strcpy(dirname,"data");
  strcpy(aname,"sales.sal");
  getrandom = FALSE;
  while(TRUE){
	get_file_name(aname);
	if(!strcmp(aname,"random")){getrandom = TRUE;break;}
	if(open_data_file(aname)){fpx=fopen(aname,"r");break;}
	}

	if(getrandom != TRUE) {fscanf(fpx,"%d %f %f",&city_top,
		    &gain2,&decline);}
	  else { outtextxy(12,70,"Cities ?   Gain  Decline");
		 get_string(10,85,0,15,aname,"20  0.2  0.01 ",BLACK,YELLOW);}
		 sscanf(aname,"%d %f %f",&city_top,&gain2,&decline);

  city = (ccity *)calloc(sizeof(ccity),city_top);
  node = (nnode *)calloc(sizeof(nnode),MAXNODES);
  ring = (float *)calloc(sizeof(float),MAXNODES);
  if(city == NULL){ printf("Memory Error-cities");exit(0);}
  if(node == NULL){ printf("Memory Error-nodes");exit(0);}

  gainx = decline/(float)city_top;

  loopi(city_top){
      if(getrandom != TRUE) {
	     fscanf(fpx,"%f %f",&city[i].x,&city[i].y);}
      else { city[i].x = random();
	     city[i].y = random();}
	   }

  sales_screen();

  node[0].x=0.5;
  node[0].y=0.5;
  node[0].cap = 0;
  node[0].close = 0;
  neigh = 1.0;
  node_top = 0;
}


index_node(i)
int i;
{ int where;float fwhere;
if(node_top == 0) return 0;
where = i - neighborhoods/2;
fwhere = (float)where/neighborhoods * 2.;
fwhere = fwhere*fwhere;
dist =  1.- fwhere;
/* if(i==min_node) dist = 1.0 ; else dist = 0.8;*/
return (min_node + i - neighborhoods/2+node_top)%node_top;


}

compute_ring()
{  int i;
   float tour=0.;
   loopi(node_top){ ring[i]=distance(node[i],node[(i+1)%node_top]);
		    tour += ring[i];  }
write_view();
   sprintf(junksx,"Tour: %3.2f",tour);write_string(30,180,junksx);
unwrite_view();
}


sales_screen()

{ int g_driver,g_mode,gerror;
  char choice;

  setviewport(0,0,639,349,1);
  setbkcolor(DARKGRAY);
  clearviewport();
  setcolor(WHITE);
  rectangle(1,1,639,349);
  setcolor(GREEN);
  setfillstyle(11,RED);
  bar(20,20,310,60);
  setcolor(WHITE);rectangle(20,20,310,60);
  write_gmenu();
  settextstyle(1,0,4);
  setcolor(GREEN);
  outtextxy(50,20,"NeuralGraphics");

  settextstyle(2,0,5);

  outtextxy(50,65,"Traveling Salesman Problem");
  setcolor(WHITE);
  rectangle(200,100,610,335);
  rectangle(330,20,609,90);
  rectangle(20,100,190,335);
  setviewport(201,101,609,334,0);

}
float random()
{ return (float)(rand() % 1000)/1100. + 0.05;
}

int s_wide,s_high;
display_cities()

{  int i;
   struct viewporttype vp;
   char number[5];
   getviewsettings(&vp);
   clearviewport();
   s_wide = vp.right-vp.left;
   s_high = vp.bottom-vp.top;
   settextstyle(2,0,5);
   setcolor(BLUE);
   movetof(node[0].x,node[0].y);
   loopi(node_top)
	linetof(node[i].x,node[i].y);
   linetof(node[0].x,node[0].y);
   loopi(node_top)circlef(node[i].x,node[i].y,2);
   loopi(city_top){
       setcolor(CYAN);
       sprintf(number,"%d",i);
       outtextxy((int)(city[i].x*(float)s_wide),(int)(city[i].y*(float)s_high),
		  number);
	setcolor(BLUE);
	circlef(city[i].x,city[i].y,3);}

     }

movetof(x,y)
float x,y;
{moveto((int)(x*(float)s_wide),
	(int)(y*(float)s_high) );}
linetof(x,y)
float x,y;
{lineto((int)(x*(float)s_wide),
	(int)(y*(float)s_high) );}

circlef(x,y,radi)
float x,y;
int radi;
{setcolor(RED);circle((int)(x*(float)s_wide),
	(int)(y*(float)s_high),radi );}


find_min(i)
int i;
{ int j;
  float dist;

   min_dist = squarex(600.);

   loopj(node_top)  {
       dist = squarex(city[i].x - node[j].x) +
	      squarex(city[i].y - node[j].y);
       if (min_dist > dist){min_dist = dist;min_node = j;} }

       if(node[min_node].count == used) {open_node(min_node);
				         city[i].inhibit = TRUE;
					 return;}


       node[min_node].count=used;

}
open_node(min_node)
int min_node;
{ int i; if(node_top > 300 ) return;
         for(i=node_top;i>min_node;i--)
         {node[i].x=node[i-1].x;
          node[i].y=node[i-1].y;
	  node[i].cap=node[i-1].cap;
	  node[i].count=node[i-1].count;
	  node[i].close = node[i-1].close;}
	  node[min_node+1].close = 0;
          node[min_node+1].count = used;
		  node_top++;
}
close_node(the_node)
int the_node;
{ int i;
         for(i=the_node;i<node_top;i++)
         {node[i].x=node[i+1].x;
          node[i].y=node[i+1].y;
	  node[i].cap=node[i+1].cap;
	  node[i].count=node[i+1].count;
	  node[i].close= node[i+1].close;}
          node_top--;
}



clear_count()
{int i;
loopi(node_top){
	if(node[i].count == 0)
	       {node[i].close +=1;
		if(node[i].close > dump) close_node(i);  }
       node[i].count = 0;}
       loopi(city_top) city[i].inhibit = FALSE;
 }

float distance(n1,n2)
nnode n1,n2;
{ float dist;
    dist = squarex(n1.x - n2.x) +
	   squarex(n1.y - n2.y);
    return sqrt(dist);
    }

write_view(){
  setcolor(YELLOW);
  setviewport(0,0,639,349,1);
}
unwrite_view()
{
  setviewport(201,101,609,334,0);
}
write_string(x,y,word)
char *word;
int x,y;
{
setcolor(YELLOW);
setfillstyle(SOLID_FILL,0);
bar(x-4,y-4,x+textwidth(word),y+textheight(word));
outtextxy(x-2,y-2,word);
}